  @echo off
setlocal enabledelayedexpansion enableextensions

rem


:CHECKHELP
	set bat_vers=1.0

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

goto :SETUP

	Flowchart:

	New changes 09/21/2011:
		
	
	
:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

echo.[!bat_log!]

	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog!
	!bat_pushecho!
	
	!bat_CALL! "!bat_exedir!\ReadParams.bat"
	
	set bat_returncode=0
	call :PARSEARGS %*
goto :MAIN %*


:PARSEARGS
!bat_pushlog! [CALL :PARSEARGS %*]

	set bat_yesno=

:PARSEARGS_LOOP
!bat_log!:PARSEARGS_LOOP [%1]

	if /i "%~1" equ "" goto :PARSEARGS_LOOPBREAK
	
	if /i "%~1" equ "-y" (
		set bat_yesno=-y
		shift
		!bat_echolog! .....................................-y detected
		goto :PARSEARGS_LOOP
	)

	if /i "%~1" equ "-output" (
		set bat_output=-o"%~2"
		!bat_echolog! -output detected - !bat_output!
		shift
		shift
		goto :PARSEARGS_LOOP
	)
	
	if /i "%~1" equ "-tzip.split" (
		set bat_type=-tzip.split
		!bat_echolog! bat_type=!bat_type!
		shift
		goto :PARSEARGS_LOOP
	)
	
	
:PARSEARGS_LOOPBREAK

	!bat_logexeclog! set bat_dest=%~1
	!bat_logexeclog! set bat_zip=%~1
	
	if /i "%~2" equ "" (
		!bat_logexeclog! set bat_src=*.*
	) else (
		!bat_logexeclog! set bat_src=%~2
	)

	
!bat_poplog! [return-:PARSEARGS] [bat_yesno=!bat_yesno!, zip[dest]="!bat_zip!", src="!bat_src!", bat_output=!bat_output!]
!bat_log!
!bat_return!



REM ======================= MAIN ===================================
REM ======================= MAIN ===================================
REM ======================= MAIN ===================================
REM ======================= MAIN ===================================
REM ======================= MAIN ===================================
REM ======================= MAIN ===================================
REM ======================= MAIN ===================================

:MAIN
!bat_pushlog! [GOTO :MAIN %*]

    if /i "!bat_type!" NEQ "-tzip.split" (
    	set bat_type=-tzip
    )

    rem !bat_logexeclog! call "!bat_exedir!\7za.exe" x -y -r -tzip.split -o"!bat_exedir!\Temp\Zip" "%~1" "*.*"

    !bat_CALL! "!bat_exedir!\7za.exe" x !bat_yesno!  -r !bat_type! !bat_output!  "!bat_zip!" "!bat_src!"
	set bat_returncode=!errorlevel!

	!bat_log! set bat_returncode=!bat_returncode!

	!bat_poplog! ENDLOCAL bat_returncode=!bat_returncode!
( ENDLOCAL & REM RETURN VALUES
	set bat_returncode=%bat_returncode%
)

!bat_log! exit /b !bat_returncode!
goto :DONE







:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo.  Usage: %~nx0 [-y] "^<zip file^>" -o"^<output dir^>" "source file spec"
	echo.
	echo.  Uses 7za.exe command line utility to unzip the files from the specified 
	echo.  zip file.
	echo.
	echo.  The optional -y command line option causes it to answer Y to overwrite questions. 
	echo.
	echo.  Wildcards or filenames with spaces must be quoted:
	echo.    "Dir\Program Files\*" 
	echo.    Dir\"Program files"\*
	echo.
	echo.  Doesn't follow the old *.* to mean any/all files. Treats *.* as matching the name
	echo.  of any file that has an extension. To process all files, you must use the
	echo.  * wildcard.
	echo.
	echo.  Backslash ('\') at the end of a path means a directory.  Without the backslash at
	echo.  the end of the path, the path can refer either to a file or a directory.
	echo.
	echo.  Example:
	echo.    %~nx0 "test.zip" -o"C:\Temp\" "test*.*"
	echo.
	call 7za.exe -h
exit /b -99

7-Zip (A) 9.20  Copyright (c) 1999-2010 Igor Pavlov  2010-11-18


:DONE
	!bat_poplog! Done with %0 %*
	!bat_log!
	