 @echo off
setlocal enableextensions enabledelayedexpansion

echo %~dp0

:SETUP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP

	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	call "!bat_exedir!\ReadParams.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	
	set bat_args=%*
	

	wmic cpu>nul:
	if %errorlevel% equ 9009 (
		exit /b
		set bat_free=9999999
		set bat_size=9999999
		set bat_freeMB=999999999
	)

	set bat_warningfile=%~0.warn.txt
	set bat_tempfile=%~0.junk.txt
	set bat_temp3=!bat_exedir!


	rem Set the target drive...
	set bat_targetlocation=!bat_exedir!
	if "%~1" neq "" (
		set bat_targetlocation=%~dpnx1
		rem remove trailing backslash
		set bat_temp3=%~dp1
		set bat_temp2=!bat_temp3:~0,-1!
	)
	
	set bat_targetdrive=!bat_targetlocation:~0,2!

	call :CALCDURATION


	set /a bat_framesPerFile=(256000000 / !bat_CAPTURE.fps! + 5) / 10

        FOR /F "tokens=*" %%G IN ('dir/b /s ^"%windir%\system32\wbem\csv.xsl^"') DO set csvdir= %%G
        set csvdir=%csvdir:~1%


	rem Note: We have to do it this way because WMIC outputs unicode and
	rem FINDSTR is not compatible with unicode strings.
	echo '    call wmic logicaldisk where "name='!bat_targetdrive!'" get Size,FreeSpace /format:"%csvdir%"^>"!bat_tempfile!"
	          call wmic logicaldisk where "name='!bat_targetdrive!'" get Size,FreeSpace /format:"%csvdir%">"!bat_tempfile!"
	for /f "usebackq delims=, tokens=1-2* skip=1" %%a in (`type "!bat_tempfile!"^|findstr /r /c:","`) do (
		set bat_free=%%b
		set bat_size=%%c
		if "!bat_free!" neq "" (
			set bat_freeMB=!bat_free:~0,-6!
		)
	)





:CHECK
	set /a bat_estCapFiles=!bat_durtotalseconds! * !bat_CAPTURE.fps! / 25600
	
	set /a bat_estSizeMB_percamera=!bat_estCapFiles!*11723/10000
	
	if not defined bat_CAPTURE.number.of.cameras (
		set /a bat_CAPTURE.number.of.cameras=1
	)
	
	if not defined bat_CAPTURE.number.of.boards (
		set /a bat_CAPTURE.number.of.boards=1
	)
	
	set /a bat_totalcameras=bat_CAPTURE.number.of.cameras * bat_CAPTURE.number.of.boards
	
		rem set the number of MB per day for all the cameras
	set /a bat_estSizeMB=bat_estSizeMB_percamera * !bat_totalcameras!

	set /a bat_14days=!bat_estSizeMB!*!bat_AUTOCAMS.diskspacewarning.days!
	set /a bat_sizediff=!bat_14days!-!bat_freeMB!
	
	set /a bat_estDaysRemain=!bat_freeMB! / !bat_estSizeMB!
	
	!bat_log! bat_estCapFiles=!bat_estCapFiles!
	!bat_log! bat_estSizeMB=!bat_estSizeMB!
	!bat_log! bat_14days=!bat_14days!
	!bat_log! bat_sizediff=!bat_sizediff!

	REM CONVERT MB TO GB
		!bat_CALL! "str_math.bat" -command "[math]::round(!bat_estSizeMB! / 1024,3)"
		!bat_logexeclog! set bat_estSizeMB=!bat_retval!

		!bat_CALL! "str_math.bat" -command "[math]::round(!bat_sizediff! / 1024,3)"
		!bat_logexeclog! set bat_sizediff=!bat_retval!


	if !bat_14days! gtr !bat_freeMB! (
		echo call :GETWINDOWSVER
		call :GETWINDOWSVER

		!bat_CALL! "str_math.bat" -command "[math]::round(!bat_freeMB! / 1024,3)"
		!bat_logexeclog! set bat_freeMB=!bat_retval!

		!bat_CALL! "str_math.bat" -command "[math]::round(!bat_14days! / 1024,3)"
		!bat_logexeclog! set bat_14days=!bat_retval!

		ECHO ********* WARNING! ************>!bat_warningfile!
		echo    [!date!  !time!] >>!bat_warningfile!
		echo    You only have !bat_freeMB! GB free on drive !bat_targetdrive!. >>!bat_warningfile!
		echo    Within the next !bat_AUTOCAMS.diskspacewarning.days! days, you will require !bat_14days! GB.>>!bat_warningfile!
		echo .>>!bat_warningfile!
		echo    Each camera is producing !bat_estCapFiles! files per !bat_duration! hours or !bat_estSizeMB_percamera! MB per camera.>>!bat_warningfile!
		echo    !bat_duration! hours per night of capture requires !bat_estSizeMB! GB per night [for !bat_totalcameras! total cameras].   >>!bat_warningfile!
		echo .>>!bat_warningfile!
		echo    You will need to free up>>!bat_warningfile!
		echo        !bat_sizediff! GB ASAP >>!bat_warningfile!
		echo        Otherwise, you have only !bat_estDaysRemain! days of capture, after which capture will fail.>>!bat_warningfile!
		echo .>>!bat_warningfile!
		echo    Tips ^(!bat_winver!^):>>!bat_warningfile!
		echo      a^) Use Autocams option 61 to archive old months SubmissionFiles>>!bat_warningfile!
		echo      b^) Try emptying the recycle bin >>!bat_warningfile!
		if "bat_winver" lss "6.0" (
			echo           ^(rd /s !bat_targetdrive!\recycler^)>>!bat_warningfile!
		) else (
			echo           ^(rd /s !bat_targetdrive!\$Recycle.Bin^)>>!bat_warningfile!
		)
		echo      c^) Use Disk Cleanup to free up temporary space and other areas.>>!bat_warningfile!
		echo      e^) Move "!bat_targetlocation!CAMS\SubmissionFiles" to an external hard drive.>>!bat_warningfile!
		echo      e^) Move "!bat_targetlocation!CAMS\CapturedFiles" to an external hard drive.>>!bat_warningfile!
		echo      f^) As a last resort, try specifying a different drive for capture >>!bat_warningfile!
		echo .>>!bat_warningfile!
		!bat_logexec! type "!bat_warningfile!"
		echo start /max notepad "!bat_warningfile!"
		     start /max notepad "!bat_warningfile!"
	) else (
		!bat_CALL! "str_math.bat" -command "[math]::round(!bat_freeMB! / 1024,3)"
		set bat_freeMB=!bat_retval!

		!bat_CALL! "str_math.bat" -command "[math]::round(!bat_14days! / 1024,3)"
		set bat_14days=!bat_retval!

		!bat_echolog!     PASSED
		!bat_echolog!        You have !bat_freeMB! GB free on drive !bat_targetdrive!. This run will
		!bat_echolog!        require !bat_estSizeMB! GB per night [for !bat_totalcameras! cameras].  The requirements over the 
		!bat_echolog!        next !bat_AUTOCAMS.diskspacewarning.days! days is: !bat_14days! GB
		!bat_echolog!        You should not encounter disk space issues during the run in the 
		!bat_echolog!        next !bat_AUTOCAMS.diskspacewarning.days! days.
		!bat_echolog!
	)

	!bat_WAIT! 5
	if exist "!bat_warningfile!" (
		if defined bat_warningfile (
			del "!bat_warningfile!"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:CHECK] Dangerous command: del "!bat_warningfile!"
		)
	)
	
	if defined bat_tempfile (
		if exist "!bat_tempfile!" (
			del /q "!bat_tempfile!"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:CHECK] Dangerous command: del /q "!bat_tempfile!"
		)
	)
goto :EOF

:GETWINDOWSVER
	echo :GETWINDOWVER wmic os get version, caption, windowsdirectory /format:list^|findstr /r /c:"=" ... "!bat_tempfile!"
	wmic os get version, windowsdirectory /format:"%csvdir%"|findstr /r /c:",">"!bat_tempfile!"
	type "!bat_tempfile!"
	for /f "usebackq delims=, tokens=1-4*" %%a in (`type "!bat_tempfile!"`) do (
		if "%%b" gtr "!" (
			set bat_winver=%%b
		)
	)
goto :EOF



:CALCDURATION

		rem Get the current date.  However, just in case the capture time has already passed, let's
		rem use tomorrow's date to get the full number of estimated hours per night of capture.
		rem We do this by calling ParseDate1.bat, which returns the ftp_year, mo, and da vars.
		rem Then we call date2jdate to get the julian date so we can add 1 to that for tomorrow.
		rem Then we run jdate2date to convert tomorrow's julian date to ftp_year, mo, and da.

	!bat_CALL! "!bat_exedir!\ParseDate1.bat"
	!bat_CALL! "!bat_exedir!\date2jdate.bat" bat_JD !ftp_year! !ftp_mo! !ftp_da!
	set /a bat_JD+=1
	!bat_CALL! "!bat_exedir!\jdate2date.bat" !bat_JD! ftp_year ftp_mo ftp_da

	for /f "delims=" %%a in  ('cscript //nologo dusk.vbs !ftp_year! !ftp_mo! !ftp_da!') do (
		!bat_logexeclog! set bat_VBTemp=%%a
	)

	for /f "tokens=1-17 delims=;" %%a in ("!bat_VBTemp!") do (
                
        set bat_onUT=%%a
		set bat_on=%%a
		set bat_duskutc=%%a
		set bat_calcedon=%%a
		
		set bat_dusklocal=%%b
		
		set bat_offset1=%%c
		
		set bat_off=%%d
		set bat_offUT=%%d
		set bat_dawnutc=%%d
		
		set bat_offtime=%%e
		set bat_offLocal=%%e
		
		set bat_offset2=%%f
		
		set bat_duration=%%g
		set bat_dur=%%g
		
		Set /a bat_durtotalsecs=%%h
		
                set bat_UTcurrent=%%i

		set ftp_hhmmssdd=%%j
		
		set bat_delaycalc=%%k
		
		set bat_walltimeron=%%l
		set bat_scheduledstarttime=%%l
		
		set bat_walltimeroff=%%m
		
		set bat_camera_temp=%%n
		
		set bat_lat=%%o
		
		set bat_lon=%%p
		
		set bat_weekday=%%q
	)

		rem Determine the duration per night and set it into bat_durtotalseconds
	if /i "%~2" neq "" (
		!bat_CALL! "!bat_exedir!\str_math.bat" "%~2*3600"
		set /a bat_durtotalseconds=bat_retval * 1
	) else (
		rem Use the DUSK.VBS hours
			!bat_CALL! "!bat_exedir!\str_math.bat" "!bat_duration! * 3600"
			set /a bat_durtotalseconds=bat_retval * 1
	)

	



:CALCDURATION_END
!bat_return!







:HELP
    echo.    %~nx0          &rem batch file name
    echo.
    echo.    Usage: %~nx0 [<drive>] [hours]" [/?]
    echo.
    echo.    If you don't specify the drive, it will assume the current drive.
    echo.    If you don't specify the hours, it will estimate based on 14 hours 
    echo.    of nighttime caputuring and the number of cameras.
    echo.
	echo.
	echo.Uses Autocams.params.ini settings:
	echo.   [CAPTURE].fps
    echo.        
exit /b


Autocams.params.ini file settings used:
bat_capture.number.of.cameras
