@echo off
setlocal enableextensions enabledelayedexpansion


	REM #################################################################################
:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

:CHECKHELP_END
goto :SETUP %*



	REM #################################################################################
:SETUP

	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	CALL "!bat_exedir!\ReadParams.bat"

	CALL "!bat_exedir!\ReadCams2Global.bat"
	
	set /a bat_boards_max=!bat_CAMS2BOARDS.number_of_boards!-1
	!bat_echolog! set bat_boards_max=!bat_boards_max!

	
	set bat_returncode=0

	for /L %%a in (0,1,2) do (
		if exist "D:\cams_board%%a\cams\capturedfiles" (
			dir "!bat_CAMS2DIR.%%a!\CapturedFiles" /s |findstr /i /c:"Dir(s)" /c:"Directory of" /c:"File(s)"
		) else (
			echo."!bat_CAMS2DIR.%%a!\CapturedFiles" has no unprocessed capture sessions
		)
	)

exit /b !bat_returncode!


:HELP
	echo.%~0      Batch Script
	echo.
	echo.Usage %~0 
	echo.
	echo.Lists each CapturedFiles directory and the number of files in each of those directories.  
	echo.
	echo.The main purpose is to help assess if there are capture sessions to process.  If the 
	echo.number of files is real low, say, less than 100 files, then you might consider deleting 
	echo.the directory and not process it. 
	echo.
	
exit /b 99

