'Option Explicit

' Flags for the options parameter
Const BIF_returnonlyfsdirs   = &H0001
Const BIF_dontgobelowdomain  = &H0002
Const BIF_statustext         = &H0004
Const BIF_returnfsancestors  = &H0008
Const BIF_editbox            = &H0010
Const BIF_validate           = &H0020
Const BIF_browseforcomputer  = &H1000
Const BIF_browseforprinter   = &H2000
Const BIF_browseincludefiles = &H4000

Set objFSO = CreateObject("Scripting.FileSystemObject")
curDir = objFSO.GetAbsolutePathName(".")
Set myLog = objFSO.CreateTextFile(curDir&"/LocaleSettings.log",true)


Dim strKey, strValue, key, data, subkeys, reg, rc, sk
Const HKCU = &H80000001
Const HKLM = &h80000002

Const StartKey    = "Control Panel"
Const SearchValue = "sTime"

Set reg = GetObject("winmgmts://./root/default:StdRegProv")

FindKey StartKey

Sub FindKey(key)
  rc = reg.GetStringValue(HKCU, key, SearchValue, data)
  If Not IsNull(data) Then
'    WScript.Echo "HKEY_CURRENT_USER\"&key & "\"
	strKey="HKEY_CURRENT_USER\"&key & "\"
  End If
  reg.EnumKey HKCU, key, subkeys
  If Not IsNull(subkeys) Then
    For Each sk In subkeys
      FindKey key & "\" & sk
    Next
  End If
End Sub
myLog.WriteLine("strKey = "&strKey) 
'wscript.echo strKey

Set objShell = WScript.CreateObject("WScript.Shell")
Dim Locale
strValue="LocaleName"
Locale=objShell.RegRead(strKey&strValue)
myLog.WriteLine("Locale = "&Locale) 
Dim sDecimal
strValue="sDecimal"
sDecimal=objShell.RegRead(strKey&strValue)
myLog.WriteLine("sDecimal = "&sDecimal) 
Dim sThousand
strValue="sThousand"
sThousand=objShell.RegRead(strKey&strValue)
myLog.WriteLine("sThousand = "&sThousand) 
Dim sNegativeSign
strValue="sNegativeSign"
sNegativeSign=objShell.RegRead(strKey&strValue)
myLog.WriteLine("sNegativeSign = "&sNegativeSign) 
Dim sPositiveSign
strValue="sPositiveSign"
sPositiveSign=objShell.RegRead(strKey&strValue)
myLog.WriteLine("sPositiveSign = "&sPositiveSign) 
Dim sList
strValue="sList"
sList=objShell.RegRead(strKey&strValue)
myLog.WriteLine("sList = "&sList) 
Dim sCurrency
strValue="sCurrency"
sCurrency=objShell.RegRead(strKey&strValue)
myLog.WriteLine("sCurrency = "&sCurrency) 
Dim sTime
strValue="sTime"
sTime=objShell.RegRead(strKey&strValue)
myLog.WriteLine("sTime = "&sTime) 
Dim sTimeFormat, bat_LOCALIZEam, bat_LOCALIZEpm
strValue="sTimeFormat"
sTimeFormat=objShell.RegRead(strKey&strValue)
myLog.WriteLine("sTimeFormat = "&sTimeFormat) 

strValue="s1159"
bat_LOCALIZEam=objShell.RegRead(strKey&strValue)
myLog.WriteLine("s1159 = "&bat_LOCALIZEam) 
if bat_LOCALIZEam="" then
  bat_LOCALIZEam="24"
end if
myLog.WriteLine("bat_LOCALIZEam = "&bat_LOCALIZEam) 
strValue="s2359"
bat_LOCALIZEpm=objShell.RegRead(strKey&strValue)
myLog.WriteLine("s2359 = "&bat_LOCALIZEpm) 
if bat_LOCALIZEpm="" then
  bat_LOCALIZEpm="24"
end if
myLog.WriteLine("bat_LOCALIZEpm = "&bat_LOCALIZEpm) 

Dim sDate
strValue="sDate"
sDate=objShell.RegRead(strKey&strValue)
myLog.WriteLine("sDate = "&sDate) 

Dim sShortDate
strValue="sShortDate"
sShortDate=objShell.RegRead(strKey&strValue)
myLog.WriteLine("sShortDate = "&sShortDate) 

WScript.Echo "Please send LocaleSettings.log to me. Script finished"