@echo off
setlocal enableextensions enabledelayedexpansion

:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)
	goto :SETUP %*

:CHECKHELP_END

	Flowchart:

	New changes 09/21/2011:
		
	
:SETUP
	!bat_WAIT!  6



	if "%~1" equ "" goto :HELP
goto :MAIN


:MAIN
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	call "!bat_exedir!\ReadParams.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	
	set bat_startlocation=!bat_camsdir!&			rem C:\CAMS
	set bat_startdrive=%~d0&					rem C:
	
rem	if /i "!bat_startlocation:~-5!" neq "\CAMS" (
rem		echo     ERROR: You must start from x:\CAMS directory. 
rem		exit /b 1
rem	)
	
	set bat_caldir=!bat_camsdir!\Cal
	
	call :TARGETDIR %*
	call :MERGECASE %*
	call :GETDETECTINFO
	call :VALIDATE01B %*
goto :DONE


:TARGETDIR
	set bat_targetdir=%~1
	set bat_targetdrive=!bat_targetdir:~0,2!
	set bat_archivedfilesdir=!bat_targetdir!

	set bat_outputfile=%bat_targetdir%\meteorcount.txt
	set bat_exedir=%~dp0::
	set bat_exedir=!bat_exedir:\::=!
	set bat_exedir=!bat_exedir:::=!
	set bat_exedrive=!bat_exedir:~0,2!
	
	set bat_dirdate=!bat_targetdir:~0,10!

	rem set bat_curryyyy=!date:~-4!
	rem set bat_currmm=!date:~4,2!
	rem set bat_currdd=!date:~7,2!
	rem set bat_currdate=!date:~-10!
	call "!bat_exedir!\localize_GETDATE2_!bat_AUTOCAMS.locale!.bat"

	!bat_echolog! bat_targetdir=!bat_targetdir!
	!bat_echolog! bat_targetdrive=!bat_targetdrive!
	!bat_echolog! bat_outputfile=!bat_outputfile!
	!bat_echolog! bat_exedir=!bat_exedir!
	!bat_echolog! bat_dirdate=!bat_dirdate!
	!bat_echolog! bat_currdate=!bat_currdate!

	if /i "!bat_targetdir!" equ "" (
		!bat_echolog!
		!bat_echolog! The bat_targetdir env var should be set to "^<drive:^>\CAMS\ArchivedFiles\^<date/time^>" format.
		!bat_echolog! Right now, it is set to [bat_targetdir="%bat_targetdir%"].
		!bat_echolog!
		set /P bat_targetdir=Manually enter the bat_targetdir value now or [Q]uit: 
		if /i "!bat_targetdir!" equ "q" goto :DONE
		goto :TARGETDIR
	)
%bat_return%


	
:VALIDATE01B
	echo.
	echo.
	set bat_choice=
	set /p bat_choice=[C]ontinue or [A]bort? 
	if /i "!bat_choice!" equ "a" goto :DONE
	if /i "!bat_choice!" neq "c" goto :VALIDATE01B

	call :METEORCALBEGIN
	if /i "!bat_choice!" equ "n" goto :APPLYBEGINX
	if /i "!bat_choice!" equ "s" goto :APPLYBEGINX
	if /i "!bat_choice!" equ "q" goto :DONE

	call :APPLYBEGINX
:APPLYREPEATX
	set /p bat_choice=[C]ontinue, or [Q]uit? 
	if /i "!bat_choice!" equ "q" goto :DONE
	if /i "!bat_choice!" neq "c" goto :APPLYREPEATX


	call :CONFIRM
	if /i "!bat_choice!" equ "q" goto :DONE
	
	call :SUBMIT
	
goto :DONE


:MERGECASE
	call MergeCaseFiles.bat "!bat_archivedfilesdir!"

	rem Get latest cal file
	set bat_latestcal=
	for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_archivedfilesdir!\FTPdetectinfo.txt"`) do (
		if not defined bat_latestcal ( set bat_latestcal=%%a )
	)
goto :EOF


:WAITFORMULTISCAN
	!bat_echolog! :WAITFORMULTISCAN %*
	!bat_echolog! for /f "usebackq tokens=*" %%a in ^(`dir "%bat_targetdir%\FTPdetectinfo_case???.txt" /s/b /a-d`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "%bat_targetdir%\FTPdetectinfo_case???.txt" /s/b /a-d`) do (
		echo     Waiting for FTP_Reprocess to release the file: "%%a"
		echo     call WaitForFile rw "%%a"
		         call WaitForFile rw "%%a"
	)
	!bat_echolog!
	


	rem temporary concat to fix the meteor count
	rem This section concats without the header
:TEMPCONCAT
	!bat_echolog! :TEMPCONCAT %*
	set bat_string= &	rem The result will be "001"+"002"+"003"...

	set /a bat_linecount=0
	!bat_echolog! for /f "usebackq tokens=*" %%a in ^(`dir "%bat_targetdir%\FTPdetectinfo_case???.txt" /s/b /a-d`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "%bat_targetdir%\FTPdetectinfo_case???.txt" /s/b /a-d`) do (
		set /a bat_linecount+=1
		if "!bat_linecount!" equ "1" (
			set bat_string="%%~a"
		) else (
			set bat_string=!bat_string!+"%%~a"
		)
	)
	!bat_echolog!     copy /y /b !bat_string! "%bat_targetdir%\FTPdetectinfo.txt"
	                  copy /y /b !bat_string! "%bat_targetdir%\FTPdetectinfo.txt"




	rem Save the meteor count into bat_count	
:GETMETEORCOUNT
	for /f "usebackq tokens=1-4" %%a in (`find /i /c ".bin" "%bat_targetdir%\FTPdetectinfo.txt"`) do (
		set bat_count=%%c
	)

	set bat_count=000000!bat_count!
	set bat_count=!bat_count:~-6!


	rem Read the FTPdetectinfo_CaseHeader.txt and Save the first 11 lines, replacing
	rem the first line with a good Meteor Count = value
:REBUILDHEADER
	set /a bat_linecount=0
	!bat_echolog! for /f "usebackq tokens=*" %%a in ^(`type "%bat_targetdir%\FTPdetectinfo_CaseHeader.txt"`^) do ...
	for /f "usebackq tokens=*" %%a in (`type "%bat_targetdir%\FTPdetectinfo_CaseHeader.txt"`) do (
		set /a bat_linecount+=1
		if "!bat_linecount!" equ "1" (
			echo Meteor Count = !bat_count!>"%bat_outputfile%"
		) else (
			if !bat_linecount! equ 5 (
				set bat_FFfolder=%%a
				set bat_FFfolder=FF  folder = !bat_targetdrive!!bat_FFfolder:~15,255!
				echo !bat_FFfolder!>>"%bat_outputfile%"
				set bat_FFfolder=!bat_FFfolder:~13,255!::
				set bat_FFfolder=!bat_FFfolder:\::=!
			) else (
				if !bat_linecount! equ 6 (
					set bat_CALfolder=%%a
					set bat_CALfolder=CAL folder = !bat_targetdrive!!bat_CALfolder:~15,255!
					echo !bat_CALfolder!>>"%bat_outputfile%"
					set bat_CALfolder=!bat_CALfolder:~13,255!::
					set bat_CALfolder=!bat_CALfolder:\::=!
				) else (
					echo %%a>>"%bat_outputfile%"
				)
			)
		)
	)
:CONCATFINAL
	!bat_echolog! copy /y /b "!bat_outputfile!"+!bat_string! "!bat_targetdir!\FTPdetectinfo.txt"
	              copy /y /b "!bat_outputfile!"+!bat_string! "!bat_targetdir!\FTPdetectinfo.txt"

	if defined bat_outputfile (
		!bat_logexec! del "!bat_outputfile!"
	) else (
		!bat_echolog! ERROR [!bat_batchfile!:CONCATFINAL] Dangerous command: del "!bat_outputfile!"
	)
	!bat_echolog!
	if not exist "!bat_targetdir!\FTPdetectinfo.txt" (
:CONCATPROMPT
		!bat_echolog! Merging the case files seems to have failed and there is not an FTPdetectinfo.txt
		!bat_echolog! file in the "!bat_targetdir!" directory.  Please resolve and then re-run
		!bat_echolog! the following command
		!bat_echolog!    %~0 %*
		set bat_choice=
		set /p bat_choice=Enter [R]estart, [C]ontinue, or [Q]uit ^(or [E]xplorer to launch Windows Explorer in this directory^): 
		if /i "!bat_choice!" equ "q" goto :DONE
		if /i "!bat_choice!" equ "c" goto :CONCATCONTINUE
		if /i "!bat_choice!" equ "r" goto :MAIN
		if /i "!bat_choice!" equ "e" (
			start Explorer /e,"!bat_targetdir!"
		)
		goto :CONCATPROMPT
	)

:CONCATCONTINUE

	!bat_echolog!
	!bat_echolog! '     Date/Time           Size           File name
	!bat_echolog! '     ------------------- -------------  ----------------------------------------------
	for /f "usebackq tokens=*" %%a in (`dir "!bat_targetdir!\FTPdetectinfo.txt" /s/b /a-d`) do (
		set bat_filesize=             %%~za
		set bat_filesize=!bat_filesize:~-13!
		set bat_filedate=%%~ta
		set bat_filename=%%a
		!bat_echolog! '     !bat_filedate! !bat_filesize!  !bat_filename!
	)
	!bat_echolog!

	!bat_echolog! '     Excerpt from "!bat_targetdir!\FTPdetectinfo.txt", please review the following: 
	!bat_echolog! '     - Meteor Count   [should be !bat_count!]
	!bat_echolog! '     - FF folder      [should be "!bat_targetdir!"]
	!bat_echolog! '     - CAL folder     [should be where the cal file is]
	!bat_echolog! '     - Cal file       [should match the date/time of file chosen in meteor cal update]
	!bat_echolog!
	!bat_echolog! '    Please wait while opening the file... [!time!]
	set /a bat_counter=0
	for /f "usebackq tokens=*" %%a in (`type "!bat_targetdir!\FTPdetectinfo.txt"`) do (
		set /a bat_counter+=1
		if !bat_counter! LSS 15 (
			!bat_echolog! '         %%a
		) else (
			if !bat_counter! equ 15 (
				!bat_echolog!
				!bat_echolog! '     Please wait while skipping the rest of the file... [!time!]
			)
		)
	)

:CONCATDISPLAY
goto :EOF

:METEORCALBEGIN
	!bat_echolog!
	!bat_echolog! ' "%bat_targetdir%\FTPdetectinfo_CaseHeader.txt"
	!bat_echolog! '    FF  folder = !bat_FFfolder!\
	!bat_echolog! '    CAL folder = !bat_CALfolder!\
	!bat_echolog!
	!bat_echolog! ' Listing all CAL files with date of "!bat_currdate!"
	dir "!bat_CALfolder!\CAL*.txt" /od|find /i "!bat_currdate!"
	!bat_echolog!
	set bat_calfilename=
	for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_archivedfilesdir!\FTPdetectinfo.txt"`) do (
		if not defined bat_calfilename ( set bat_calfilename=%%a)
	)
	!bat_echolog! ' Cal file information from the Cal file used in the current 
	!bat_echolog! ' FTPdetectinfo.txt file (Probably not current):
	call GetCalfileInfo.bat "!bat_calfilename!"
	!bat_echolog!
	!bat_echolog! ' Ensure that the FF and CAL folders are correct..
	set bat_choice=
	set /p bat_choice=     Run Meteor Cal [U]pdate, Meteor [C]al, [S]kip calibration, or [Q]uit? 
	if /i "!bat_choice!" equ "u" call :CALUPDATE& goto METEORCAL02
	if /i "!bat_choice!" equ "c" call :METEORCAL& goto METEORCAL02
	if /i "!bat_choice!" equ "s" goto :EOF
	if /i "!bat_choice!" equ "q" goto :EOF
	goto :METEORCALBEGIN


:CALUPDATE
	cd /d "!bat_exedir!"
	!bat_echolog! call "!bat_exedir!\FTP_MeteorCal_Update.exe"
	              call !bat_exedir!\FTP_MeteorCal_Update.exe"
	cd /d "!bat_exedir!"
	!bat_echolog!
	!bat_echolog! ' Be sure to write down the date/time of the FF file used for calibration.
	pause
	!bat_echolog!
goto :METEORCAL02


:METEORCAL
	cd /d "!bat_exedir!"
	!bat_echolog! '     call echo.^|"!bat_exedir!\FTP_MeteorCal.exe"
			            call echo.|"!bat_exedir!\FTP_MeteorCal.exe"
	cd /d "!bat_exedir!"
	!bat_echolog!
	!bat_echolog! ' Be sure to write down the date/time of the FF file used for calibration.
	pause
	!bat_echolog!
goto :METEORCAL02


:METEORCAL02
	!bat_echolog!
	!bat_echolog! ' Listing all CAL files with date of "!bat_currdate!"
	dir "!bat_CALfolder!\CAL*.txt" /od|find /i "!bat_currdate!"
	!bat_echolog!
	!bat_echolog! '     for /f "usebackq tokens=*" %%a in ^(`dir "!bat_CALfolder!\CAL*.txt" /s/b /od`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_CALfolder!\CAL*.txt" /s/b /od`) do (
		set bat_tempdate=%%~ta
		set bat_tempdate=!bat_tempdate:~-0,10!
		if /i "!bat_tempdate!" equ "!bat_currdate!" (
			set bat_calfilename=%%a
		)
	)
	call GetCalfileInfo.bat "!bat_calfilename!"
	!bat_echolog!
	set bat_choice=
	set /p bat_choice=     Do you wish to re-run the meteor cal [U]pdate, run meteor [C]al, [N]ext step, or [Q]uit? 
	if /i "!bat_choice!" equ "u" goto :CALUPDATE
	if /i "!bat_choice!" equ "c" goto :METEORCAL
	if /i "!bat_choice!" equ "n" goto :EOF
	if /i "!bat_choice!" equ "q" goto :EOF
goto :METEORCAL02


rem *************************************************************
rem ***** This should be made into a standalone batch file ******
rem *************************************************************
:APPLYBEGINX
	cd /d "!bat_exedir!"
	!bat_echolog! ' call "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!"
	                call "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!"
	cd /d "!bat_exedir!"
goto :APPLYREPEATX
!bat_echolog! goto :EOF
goto :EOF




:CONFIRM
	!bat_echolog!
	set bat_choice=
	set /p bat_choice=Are you ready for FTP_Confirmation or [Y/Q]? 
	if /i "!bat_choice!" equ "q" goto :EOF
	if /i "!bat_choice!" equ "y" goto :CONFIRM2
	goto :CONFIRM

:CONFIRM2
	!bat_echolog! call FTP_Confirmation
	              call FTP_Confirmation
goto :EOF


:SUBMIT
	!bat_echolog!
	set bat_choice=
	set /p bat_choice=     Ready for submission2 "!bat_targetdir!" ?  Y/N 
	if /i "!bat_choice!" equ "n" goto :EOF
	if /i "!bat_choice!" neq "y" goto :SUBMIT

	call "!bat_exedir!\submission2.bat" "!bat_targetdir!"
	!bat_echolog!
	!bat_echolog!
goto :EOF




:GETDETECTINFO
	set /a bat_linecount=0
	rem echo for /f "usebackq tokens=*" %%a in ^(`type "!bat_archivedfilesdir!\FTPdetectinfo_CaseHeader.txt"`^) do ...
	for /f "usebackq tokens=*" %%a in (`type "!bat_archivedfilesdir!\FTPdetectinfo_CaseHeader.txt"`) do (
		set /a bat_linecount+=1
		if "!bat_linecount!" equ "1" (
			set bat_count=%%a
			set bat_count=!bat_count:~15,6!
		) else (
			if !bat_linecount! equ 5 (
				set bat_FFfolder=%%a
				set bat_FFfolder=FF  folder = !bat_targetdrive!!bat_FFfolder:~15,255!
				set bat_FFfolder=!bat_FFfolder:~13,255!::
				set bat_FFfolder=!bat_FFfolder:\::=!
			) else (
				if !bat_linecount! equ 6 (
					set bat_CALfolder=%%a
					set bat_CALfolder=CAL folder = !bat_targetdrive!!bat_CALfolder:~15,255!
					set bat_CALfolder=!bat_CALfolder:~13,255!::
					set bat_CALfolder=!bat_CALfolder:\::=!
				) else (
					if !bat_linecount! equ 13 (
						set bat_fffilename=%%a
					) else (
						if !bat_linecount! equ 14 (
							set bat_calfilename=%%a
						) else (
							rem echo %%a
						)
					)
				)
			)
		)
	)
goto :EOF


:ECHOLOG
	rem Echo to the console and to the bat_logfile
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.>>"!bat_logfile!"
		echo.
		%bat_return%
	)

	set bat_echolog_temp=%*

	echo %bat_echolog_temp%>>"!bat_logfile!"
	echo %bat_echolog_temp%
%bat_return%


:LOG
	rem Echo only to the bat_logfile.
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.>>"!bat_logfile!"
		%bat_return%
	)

	set bat_echolog_temp=%*

	echo %bat_echolog_temp%>>"!bat_logfile!"
%bat_return%





:HELP
	echo %~0      Batch Script
	echo.
	echo     Usage %~0 ^<target directory^>
	echo.
	echo     Example: 
	echo        %~0 "C:\CAMS\ArchivedFiles\2011_10_21_01_58_22"
	echo.
	echo     The target directory must be a fully qualified name
	echo     with the drive letter. 
	echo.
	echo     This script performs or initiates many of the tasks that
	echo     need to be done daily after the ftp_reprocess phase is
	echo     complete.  It assumes that the ftp_reprocess phase was
	echo     completed using the "makeCaseListing.bat" script, which
	echo     produces different outcome than the standard ftp_reprocess
	echo     output.  
exit /b



:DONE
	for /f "usebackq tokens=*" %%a in (`set bat_`) do (
		!bat_echolog! %%a
	)

