

	dim oFSO

	Const ForAppending = 8
	Const ForReading = 1
	Const ForWriting = 2

	Set oFSO = CreateObject("Scripting.FileSystemObject") 
	
		' set file and directory names
	DetectFile=oFSO.GetAbsolutePathName(WScript.Arguments.Item(0))
	DetectDir=oFSO.GetParentFolderName(DetectFile)
	HeaderFile=DetectDir & "\SortDetect_header.txt"
	SortDetect_DetectFile_Root=DetectDir & "\SortDetect_"
	CameraListFile=DetectDir & "\SortDetect_CameraList.txt"

	WScript.Echo    "    DetectFile=" & DetectFile
	WScript.Echo    "    DetectDir =" & DetectDir
	WScript.Echo    "    HeaderFile=" & HeaderFile
	WScript.Echo    "    SortDetect=" & SortDetect_DetectFile_Root
	WScript.Echo    "CameraListFile=" & CameraListFile
	'  wscript.echo    "    basename=" & oFSO.GetBaseName(DetectFile)

	wscript.echo CStr(oFSO.GetFile(DetectFile).size)

	if oFSO.FileExists(CameraListFile) = False then
		WScript.echo "    ###ERROR - Missing " & CameraListFile
		WScript.Quit 1
	end if


	If oFSO.GetFile(DetectFile).Size > 0 Then 
  

		set oGCFC = oFSO.OpenTextFile(CameraListFile, 1)
		aGCFC = Split(oGCFC.ReadAll, VbCrLf)

		Set oInFile = oFSO.OpenTextFile(DetectFile, 1) 
		aData = Split(oInFile.ReadAll, VbCrLf)
		oInFile.Close 
		wscript.echo "Total Lines=" + CStr(Ubound(aData))


			' Write the detect Header to the HeaderFile
		If oFSO.GetFile(DetectFile).Size > 0 Then 
			Set oOutFile = oFSO.OpenTextFile(HeaderFile, 2, True) 
			If UBound(aData) > 11 Then 
				
				For i = 0 To 10
				  oOutFile.WriteLine aData(i) 
				Next 
				
				oOutFile.Close 
			End If 
		End If 


			' Now process the part of the detect file below the header section...
			' This section loops through each camera in the GCFC.log file and 
			' outputs the sections that pertain to the first camera, then it
			' goes to the next camera, and so on. 
		For each camera_temp in aGCFC
	
			if camera_temp <> "" Then
				temp_track_file=SortDetect_detectfile_root + camera_temp + ".txt"
				WScript.Echo "     " + temp_track_file + "   """ + camera_temp & """"

					' Open "D:\cams16\CAMS\ArchivedFiles\2017_09_15_03_00_00\SortDetect_??????.txt" for appending [8]
				Set oOutFile = oFSO.OpenTextFile(temp_track_file, 8, True)

				If UBound(aData) >= 11 Then 
				  new_track=false
				  track_count=0
				  track_linecount=0
				  skip=true

				  For i = 11 To UBound(aData) - 1
					temp=aData(i)

					if temp="-------------------------------------------------------" Then
					  new_track=true
					  track_count = track_count + 1
					  track_linecount=1
					  save_line=temp
					  skip=false
					Else
					  new_track=false
					  track_linecount = track_linecount + 1

					  if track_linecount = 2 Then
						camera_in_file = mid(temp,4,6)

						if camera_in_file = camera_temp Then
							oOutFile.WriteLine(save_line)
							oOutFile.WriteLine(temp)
						end if
					  Else
					  	if camera_in_file = camera_temp then
							oOutFile.WriteLine(temp)
						end if
					  End If
					end if
				  Next 

				End If 

				oOutFile.Close
			End if

		next

		oGCFC.Close
	End If 
	
	
	
