
@echo off
setlocal enableextensions enabledelayedexpansion

	REM #########################################################################
	REM 

:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)
	
rem 	if /i "%~1" EQU "" (goto :HELP)

:CHECKHELP_END
goto :SETUP %*

	REM #########################################################################
	REM 

:SETUP

	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	CALL "!bat_exedir!\ReadParams.bat"
	
	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!


rem set bat_indent_log_debug=true

		rem Get the bat_capturedfilesdir value
	CALL "!bat_exedir!\ReadConfig.bat"

	CALL "!bat_exedir!\ReadCams2Global.bat"

	set /a bat_boards_max=!bat_CAMS2BOARDS.number_of_boards!-1
	!bat_log! set bat_boards_max=!bat_boards_max!
	
	set bat_downloads_dir=%USERPROFILE%\downloads
	
	
	set bat_tempdir=!bat_CAMS2QUEUE.queue_dir!\Temp
	
	set bat_repackageddir=!bat_CAMS2QUEUE.queue_dir!\Repackaged
	
	
goto :MAIN %*
	


	REM #########################################################################
	REM 

:MAIN
!bat_pushlog! [GOTO !bat_batchfile!:MAIN] [%*]

	set bat_downloads_dir
	dir /b /a-d /on "!bat_downloads_dir!\*.001"
	

	!bat_pushecho! for /f "usebackq tokens=*" ..a in ^(`dir /b /a-d /on "!bat_downloads_dir!\*.001"`^) do ^(
	for                /f "usebackq tokens=*" %%a in  (`dir /b /a-d /on "!bat_downloads_dir!\*.001"`) do (
		
		set bat_zipfile_name=%%~nxa
		set bat_zipfile_ext=%%~xa
		set bat_zipfile_name_zip=!bat_zipfile_name:~0,-4!
		set bat_zipfile_full=!bat_downloads_dir!\!bat_zipfile_name!
		
		set bat_queuefile_full=!bat_CAMS2QUEUE.queue_dir!\!bat_zipfile_name_zip!
		
		set bat_zipfile
		

		!bat_logexec! del /q "!bat_tempdir!\*.*"
		
		!bat_call! "!bat_exedir!\7unzip.bat" -y -tzip.split "!bat_zipfile_full!" -o"!bat_tempdir!" "*.*"
		
		!bat_call! "!bat_exedir!\7za.exe" a   -tzip -y "!bat_queuefile_full!" "!bat_tempdir!\*.*"
		if !errorlevel! neq 0 (
			dir /b /a-d ""
			!bat_pause! 86 - Failed to zip.
		)
		
		!bat_logexec! DEL /q "!bat_tempdir!\*.*"
		
		!bat_logexec! MOVE /Y "!bat_downloads_dir!\!bat_zipfile_name_zip!*.*" "!bat_repackageddir!"
		
	)
	!bat_popecho! ^)
	
	goto :MAIN_END
:MAIN_END
!bat_poplog! [END-!bat_batchfile!:MAIN] - goto :DONE
goto :DONE


	REM #########################################################################
	REM 

:HELP
	echo.%~0      Batch Script
	echo.
	echo.     Usage %~0 ^<split zip file name w/o path^>  
	echo.
	echo.    Repackages split zip files that are in the downloads dir and rezips them into a single
	echo.    zip file.
    echo.
	echo.     Example: 
	echo.        %~0 "2011_10_21_000533_01_58_22_01.zip.001"
	echo.
	echo.
!bat_return! 99






	REM #########################################################################
	REM 

:DONE
	!bat_popecho! [goto !bat_batchfile!:DONE] [bat_returncode=!bat_returncode!]
	!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_echolog! exit /b !bat_returncode!
exit /b !bat_returncode!
