  @echo off
setlocal enabledelayedexpansion enableextensions


:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

goto :SETUP

	Flowchart:

	New changes 09/21/2011:
		
	
	
:SETUP
	
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"


	!bat_log! =============================================================
	!bat_log! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_log! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushlog!

	!bat_CALL! "!bat_exedir!\ReadParams.bat"

	if /i "!bat_paramsfile!" equ "" (
		set bat_paramsfile=!bat_exedir!\AutoCams.Params.ini
	)

goto :MAIN



:MAIN
		REM check if it's on
	findstr /B /i "bat_indent_log_debug=false" "!bat_paramsfile!"
	set bat_returncode=!errorlevel!
	
	echo.findstr /B /i "bat_indent_log_debug=false" "!bat_paramsfile!" [yields !bat_returncode!]==========
	
	
	if !bat_returncode! equ 0 (
		!bat_echolog! Toggling debug ON [!bat_returncode!]
		!bat_logexec! call "!bat_exedir!\ReplaceText.exe" -V --c-style "!bat_paramsfile!" bat_indent_log_debug=false bat_indent_log_debug=true>nul:
		set bat_indent_log_debug=true
	) else (
		!bat_echolog! Toggling debug OFF [!bat_returncode!]
		!bat_logexec! call "!bat_exedir!\ReplaceText.exe" -V --c-style "!bat_paramsfile!" bat_indent_log_debug=true bat_indent_log_debug=false>nul:
		set bat_indent_log_debug=false
	)

:MAIN_END
	

goto :DONE













:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0  [/?]
	echo.
	echo.Toggles the setting.  When it is setto 'true', the logging output
	echo.is also echoed to the console.  Otherwise, it only goes to the log
	echo.and is, thus, hidden from view.
	echo.
	echo.Current setting is:
	findstr /B /i "bat_indent_log_debug=" "!bat_paramsfile!"
	echo.
	findstr /B /i "bat_indent_log_debug=true" "!bat_paramsfile!">nul:
	if !errorlevel! equ 0 (
		echo.   Debugging is [On]
	) else (
		echo.   Debugging is [Off]
	)
	echo.
	echo.
exit /b -99



:DONE
!bat_poplog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!bat_echolog!


ENDLOCAL & (
	echo.ENDLOCAL SET bat_indent_log_debug=%bat_indent_log_debug%
	SET bat_indent_log_debug=%bat_indent_log_debug%
)

EXIT /b 0
