@echo off
setlocal enableextensions enabledelayedexpansion

	REM ##############################################################
	REM :CHECKHELP
	REM
	
:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

:CHECKHELP_END
goto :SETUP %*





	REM ##############################################################
	REM :SETUP
	REM
	
:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	CALL "%~dp0indent_setup.bat"
	
	if not defined bat_COMMENT_BEGIN (
		set bat_pushstring=
	)

	call "!bat_exedir!\ReadParams.bat"


	!bat_log!
	!bat_log! =============================================================
	!bat_log! [%date% %time%] - Version: [!bat_vers! - %~dpnx0 %*]
	!bat_log! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushlog!



	set bat_tempfile=%~dpnx1
	set ftp_wmicfile=!bat_tempfile:\=\\!

		REM ftp_wmictime=20180207022405.010611-480
	set /a bat_tempcount=0		
rem	!bat_echolog! for /f "usebackq tokens=* skip=1" ..a in ^(`wmic DataFile where "Name='!ftp_wmicfile!'" GET LastModified`^) do ^(
	for               /f "usebackq tokens=* skip=1" %%a in  (`wmic DataFile where "Name='!ftp_wmicfile!'" GET LastModified`) do (
		set /a bat_tempcount+=1
 
		if /i "!bat_tempcount!" equ "1" (
			set ftp_wmictime=%%a&					REM 20180207022405.010611-480

			set ftp_wmictime_date=!ftp_wmictime:~0,8!&		REM 20180207
			set ftp_wmictime_time=!ftp_wmictime:~8,13!&		REM 022405.010611
			set ftp_wmictime_usec=!ftp_wmictime_time:~-6!&		REM 010611
			set ftp_wmictime_offset=!ftp_wmictime_time:~21,4!&	REM -480

		)
	)


PUSHD "%~dp1"


	set ftp_z=0000000000
	set ftp_sed=

REM	!bat_log! for /f "usebackq tokens=1-8* delims=/:~" ..a in ^(`forfiles /m "%~nx1" /c "cmd /c echo.@fdate~@ftime~@fsize"`^) do ^(
	for           /f "usebackq tokens=1-8* delims=/:~" %%a in  (`forfiles /m "%~nx1" /c "cmd /c echo.@fdate~@ftime~@fsize"`) do (
rem		echo.a=%%a, b=%%b, c=%%c, d=%%d, e=%%e, f=%%f, g=%%g, h=%%h
		
		set ftp_temp=!ftp_z!%%a
		set ftp_mo=!ftp_temp:~-2!
		
		set ftp_temp=!ftp_z!%%b
		set ftp_da=!ftp_temp:~-2!
		
		set ftp_temp=!ftp_z!%%c
		set ftp_year=%%c
		
		set ftp_temp=!ftp_z!%%d
		set ftp_hh=!ftp_temp:~-2!
		
		set ftp_temp=!ftp_z!%%e
		set ftp_mi=!ftp_temp:~-2!

		set ftp_temp=%%f
		set ftp_temp=!ftp_z!!ftp_temp:~0,2!
		set ftp_se=!ftp_temp:~-2!
		
		set ftp_ampm=%%f
		set ftp_ampm=!ftp_ampm:~-2!
		
		set ftp_filesize=%%g
	)
REM	!bat_log! ^)
POPD

	set ftp_z=
	set ftp_temp=
	
	set bat_tempfile_date=!ftp_mo!/!ftp_da!/!ftp_year! !ftp_hh!:!ftp_mi!:!ftp_se!!ftp_wmictime_time:~-7! !ftp_ampm!

	call "!bat_exedir!\PARSETIME1.bat" "!bat_tempfile_date!"


 rem set ftp_


goto :DONE











:HELP
	echo.Usage: call "%~dpnx0" [file_full]
	echo.
	echo.Using the specified file, the local timestamp is determined and then
	echo.that date/time is passed to getTimestamp2.bat to convert it to UTC. 
	echo.
	echo.Returns:
	echo.  environment variables using the ENDLOCAL command:
	echo.	ftp_year                 The 4 digit year with leading zeros
	echo.
	echo.	ftp_mo                   The two digit month with leading zeros
	echo.
	echo.	ftp_mo2                  Numeric month value [no leading zero]
	echo.
	echo.	ftp_da                   Two digit day with leading zeros
	echo.
	echo.	ftp_da2                  Numeric day value [no leading zero]
	echo.
	echo.	ftp_LocalDate            e.g. 12/25/2014 in en-US and 2014/12/25 in nl-BE
	echo.
	echo.The returned date is localized current locale format 
	ecgi.where the local date is returned according to: bat_LOCALIZE.format.date
	echo.
	echo.Example:
	echo.  If the date is October 5, 2013, this routine should result with:
	echo.    ftp_year=2013
	echo.    ftp_mo=10
	echo.    ftp_da=05
	echo.    ftp_LocalDate=10/13/2013
	echo.
	echo.This routine does not need to be modified for each locale, since it was written in a way to
	echo.avoid that requirement.
	echo.
	echo.The trick is in the construct of the ENDLOCAL command, where it passes
	echo.back variables that are local to this routine.
	echo.




:DONE
	!bat_pop!
	!bat_log! [!date!, !time!] !bat_batchfile!:DONE] %~dpnx0 %*
	!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_log!

		REM from ParseDate1.bat


	ENDLOCAL & (
		SET ftp_hhmmssdd=%ftp_hhmmssdd%
		set ftp_hr=%ftp_hr%
		set ftp_mi=%ftp_mi%
		set ftp_se=%ftp_se%
		set ftp_sed=%ftp_sed%
		set ftp_jd=%ftp_JD%
		set ftp_hhmmssdd_local=%ftp_hhmmssdd_local%
		
		set ftp_wmictime=%ftp_wmictime%
		set ftp_wmictime_date=%ftp_wmictime_date%
		set ftp_wmictime_time=%ftp_wmictime_time%
		set ftp_wmictime_usec=%ftp_wmictime_usec%
		set ftp_wmictime_offset=%ftp_wmictime_offset%
		
		REM from ParseDate1.bat
		SET ftp_wmdy=%ftp_wmdy%
		set ftp_year=%ftp_year%
		set ftp_mo=%ftp_mo%
		set ftp_mo2=%ftp_mo2%
		set ftp_da=%ftp_da%
		set ftp_da2=%ftp_da2%
		set ftp_www=%ftp_www%
		set bat_twilight_searchstr=%bat_twilight_searchstr%
		set ftp_LocalDate=%ftp_LocalDate%
		
		set ftp_cams_zulu=%ftp_cams_zulu%
		set ftp_8601_local=%ftp_8601_local%
		set ftp_8601_zulu=%ftp_8601_zulu%
		set ftp_cams_local=%ftp_cams_local%
		
		set ftp_filesize=%ftp_filesize%
	)


	REM Display the output.  Once you get this working, REM out this line
	rem SET ftp_

exit /b 0
