
:INDENT_PAUSE
	set bat_indent_pause=
	echo.!bat_pushstring!INDENT_PAUSE.BAT - !bat_batchfile!
rem	echo.!bat_pushstring![bat_logfile_full="!bat_logfile_full!"]
	echo.!bat_pushstring!Press [Enter] to continue [Q] to send quit to calling program. 
	echo.!bat_pushstring!Or [command]. Ctrl+C to Exit or [A]bort with environment variables [%*]. 
	!bat_log! set /p bat_indent_pause=!bat_pushstring!%* 

	set /p bat_indent_pause=!bat_pushstring! %* 

	echo.bat_indent_pause=[!bat_indent_pause!]
	echo.

	if "!bat_indent_pause!" equ "" goto :INDENT_PAUSE_END

	if "!bat_indent_pause!" equ "a" goto :INDENT_PAUSE_ABORT

	if "!bat_indent_pause!" equ "q" (
		goto :INDENT_PAUSE_QUIT
	)


	if /i "!bat_indent_pause:~0,5!" equ "goto " (
		!bat_return!&!bat_indent_pause!
		echo.
		echo.!bat_pushstring!indent_pause.bat:GOTO :EOF - !bat_indent_pause!
		echo.
	)


	if /i "!bat_indent_pause!" equ "?" (
		CALL :HELP
		echo.
		goto :INDENT_PAUSE
	)

		rem If you get to here, then just invoke the command string as entered by the user.
	!bat_push!
		!bat_log! !bat_indent_pause!
		          !bat_indent_pause!
		echo.
	!bat_pop!
	
	goto :INDENT_PAUSE
	
:INDENT_PAUSE_END
!bat_return! 0

:INDENT_PAUSE_QUIT
	call "!bat_exedir!\clear_bat_vars.bat"

		REM force a syntax error in orderto guarantee that all loops and subroutines are aborted asap.
	for /f "useback" forcing_error_to_exit_variables_cleared in (1,1,1)) do (x)

:INDENT_PAUSE_QUIT_END

!bat_return! 9998

:INDENT_PAUSE_ABORT
		REM force a syntax error in orderto guarantee that all loops and subroutines are aborted asap.
	for /f "useback" forcing_error_to_exit_variables_remain in (1,1,1) do (x)

:INDENT_PAUSE_ABORT_END
!bat_return! 9999 


:HELP
	!bat_push!
	echo.Instructions:
	echo.
	echo.Usage: ^^!bat_pause^^! The value of bat_xyz=[^^!bat_xyz^^!]
	echo.
	echo.Ideal for debugging batch scripts by acting like a kind of source level
	echo.breakpoint.  When the script hits the !bat_pause! statement, it displays
	echo.prompt text, but it allows you to enter commands, look at variables
	echo.and their values, and even change them.
	echo.
	echo.A common function is to examine the variables in the script.  For example:
	echo.You can enter:  set bat_capture
	echo.
	echo.and it will display all the variables whose name starts with bat_capture.
	echo.
	echo.It Displays:
	echo.	^<indent spacing^>Press [Enter] to continue, Any char to abort [^<argument list^>]
	echo.	^<indent spacing^>^<argument list^>
	echo.
	echo.When the user presses [Enter], it returns.  However, if you are running bat_PAUSE
	echo.because you entered: ddd      to a bat_PROMPT, this will return you to the 
	echo.bat_PROMPT so you can continue.
	echo.
	echo.If the user enters SET and then an environment variable name, or part of a variable name, 
	echo.the variable[s] and their values are listed.
	echo.
	echo.When the user presses any other key, it forces a syntax error and aborts. When 
	echo.that happens, the dos prompt is displayed, however, even though SETLOCAL was 
	echo.used, the environment variables are still set - for you to examine. 
	echo.
	echo.When the user presses [Q], it sends "Q" to the calling program
	echo.It can test for: 
	echo.   if /i "^!bat_indent_pause^!" equ "q" ^(echo.quitting^)
	echo.
	echo.If you want to execute another variable as a command,
	echo.find out the value of the variable and use that.
	echo.
	echo.  Example:  Instead of ^^!bat_logexec^^! dir *.txt
	echo.   do this:            set bat_logexec
	echo.   returns:   call "C:\CAMS\indent_logexec.bat"
	echo.   therefore do this:
	echo.                       call "c:\cams\indent_logexec.bat" dir *.txt
	echo.
	!bat_pop!
!bat_return! 99
