  @echo off
setlocal enabledelayedexpansion enableextensions

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

:CHECKHELP

	
	echo.
goto :SETUP


:SETUP

call "%~dp0clear_bat_vars.bat"
set bat_TITLE_string= 
TITLE !bat_TITLE_string!

	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"
rem	!bat_CALL! "!bat_exedir!\ReadParams.bat"

set bat_indent_log_debug=true

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! [%date% %time%] - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	
	!bat_log! bat_log - aaaaaaaaaaaaaaaaaaaaaa
	
	!bat_pushecho!
	!bat_pushecho! PUSHECHO
	!bat_pushlog! PUSHLOG
	!bat_popecho! POPECHO
	!bat_poplog! POPLOG
	!bat_CALL!    "bat_CALL"
	!bat_CALLecho! "bat_CALLecho"
	
	







:HELP
	echo.Usage: call "%~nx0"
	echo.
	echo.Forwards the command line to test sub-scripts by providing all the extra
	echo.indent and debugging infrastructure.  That way, it can simulate how the
	echo.subscripts are called by autocams.bat and other main scripts.
	echo.
	echo.This is especially useful for those scripts that you want to test, but they
	echo.don't stand alone, such as FTPhash.bat, GetCameraList.bat, ReadParams.bat, etc.
	echo.
	echo.Returns:
	echo.  nothing
	echo.
	echo.Example(s):
	echo.    %~f0 FTPhash test.zip
	echo.
	echo.After it calls the FTPhash script, the environment variables can be 
	echo.compared.
	echo.
exit /b -99



