
   @echo off
setlocal enableextensions enabledelayedexpansion

:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"
	if not defined bat_COMMENT_BEGIN (
		set bat_pushstring=

		call "!bat_exedir!\ReadParams.bat"
	)

	call :GETONTIME

	ENDLOCAL & (
		SET bat_ON=%bat_ON%
	)

exit /b 0



:GETONTIME
!bat_pushlog! [CALL !bat_batchfile!:GETONTIME] %*
	SET bat_ON=

	rem LOCALIZE HERE: Should be in the format: hh:mm:ss
	set bat_ON=!time:~0,8!
:GETONTIME2

:GETONTIME_END
!bat_poplog! [RETURN !bat_batchfile!:GETONTIME] [bat_ON=!bat_ON!, time=!time!]
!bat_log!
!bat_return!




:HELP
	echo.Usage: call "bat_exedir\localize_GETONTIME1_en-US.bat"
	echo.
	echo.Returns:
	echo.  environment variable: bat_ON
	echo.
	echo.The returned time needs to be in the "en-US" locale format where
	echo.the local time is returned in 24 hour time with colon separators 
	echo.between hours, minutes, and seconds (hh:mm:ss)
	echo.
	echo.Example:
	echo.  If the local time is 7:47:33.98 PM, this routine should result
	echo.  in the bat_ON variable set to: 19:47:38
	echo.
	echo.This is the "en-US" local version of this script and it will serve
	echo.as a template for others to develop localized versions of this script.
	echo.



