
   @echo off
setlocal enableextensions enabledelayedexpansion

:CHECKHELP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP


:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	if not defined bat_COMMENT_BEGIN (
		set bat_pushstring=

	)

	if not defined bat_LOCALIZE.locale (
		call "!bat_exedir!\ReadParams.bat"
	)

	!bat_log!
	!bat_log! =============================================================
	!bat_log! [%date% %time%] - Version: [!bat_vers! - %~dpnx0 %*]
	!bat_log! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushlog!

	call :GETONTIME

goto :DONE


:GETONTIME
!bat_pushlog! [CALL !bat_batchfile!:GETONTIME] %*
	SET bat_ON=

	rem LOCALIZE HERE: Should be in the format: hh:mm:ss
	set bat_ON=!time:~0,8!
:GETONTIME2

:GETONTIME_END
!bat_poplog! [RETURN !bat_batchfile!:GETONTIME] [bat_ON=!bat_ON!, time=!time!]
!bat_log!
!bat_return!




:HELP
	echo.Usage: call "%~nx0"
	echo.
	echo.Gets the current time into the bat_ON variable.
	echo.
	echo.Returns:
	echo.  environment variable: bat_ON
	echo.
	echo.The returned time is in the format of the current Locale.
	echo.



:DONE
	!bat_pop!
	!bat_log! [!date!, !time!] !bat_batchfile!:DONE] %~dpnx0 %*
	!bat_log! [ENDLOCAL bat_ON=!bat_ON!]
	!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_log! 

	ENDLOCAL & (
		set bat_ON=%bat_ON%
	)

exit /b 0
