
@echo off
setlocal enableextensions enabledelayedexpansion

:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

:CHECKHELP_END
goto :SETUP %*

:SETUP
	if "%~1" equ "" goto :HELP

	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	call "!bat_exedir!\ReadParams.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! [%date% %time%] - Version: !bat_vers! - %~dpnx0 %*
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!

		rem Get the bat_capturedfilesdir value
	!bat_CALL! "!bat_exedir!\ReadConfig.bat"

	set bat_targetdate=%~1
	!bat_logexeclog! set bat_targetdate=!bat_targetdate:_=!

	!bat_logexeclog! set bat_caldir=!bat_camsdir!\Cal

goto :MAIN %*


:MAIN
!bat_pushlog! [GOTO !bat_batchfile!:MAIN] %*

	set bat_returncode=0

	
	!bat_echolog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_caldir!\CAL_??????_!bat_targetdate!_*.txt" /s/b /a-d /o-n`^) do ^(
	!bat_echolog!

			echo.!bat_pushstring!CAL file name                 		          Size		Date/Time
			echo.!bat_pushstring!------------------------------		--------------		--------------------

	for               /f "usebackq tokens=*" %%a in  (`dir "!bat_caldir!\CAL_??????_!bat_targetdate!_*.txt" /s/b /a-d /o-n`) do (

		REM %%a=CAL_000250_20170915_103045_826.txt
		
		set bat_temp=            %%~za&			REM "            8807"
		set bat_temp=!bat_temp:~-14!&			REM "          8807"

			REM -IF EXIST - If "d:\cams16\cams\cal\CAL_000250_20170915_103045_826.txt" in the  "..\Cal\" dir...
		(echo.%%~a|findstr /r /i /c:"\\cams\\Cal\\CAL_[0-9]">nul: 2>&1) && (
			echo.!bat_pushstring!%%~nxa		!bat_temp!		%%~ta
		)
	)
	
	!bat_echolog!
	!bat_echolog!


:MAIN_END
!bat_poplog! [END-!bat_batchfile!:MAIN] - goto :DONE
goto :DONE













:HELP
	echo %~0      Batch Script
	echo.
	echo     Usage %~0 ^<yyyymmdd^>
	echo.
	echo.    Where yyyymmdd is a date compatible with cal file dates.
	echo.
	echo     Example: 
	echo        %~0 "2011_10_21"
	echo.
	echo     Outputs a list of cal files for the given date, ordered by
	echo     camera, then date.  
	echo.
exit /b



:DONE
	!bat_poplog! [goto !bat_batchfile!:DONE] [bat_returncode=!bat_returncode!]
	!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_log! exit /b !bat_returncode!
	          exit /b !bat_returncode!
