






		REM ===============================================================
		REM These next few lines pertain to locking the AutoCams menu options
		REM from being selected until AutoCal_LocalDownload.bat (remote autocal
		REM phase 3) is complete.  When it's done, it will unlock the 
		REM "RemoteSession_Busy.txt" file and then lock the "AutoCams_Busy.txt"
		REM file to prevent "AutoCal_LocalDownload.bat" from running at the
		REM same time.
		REM
		REM echo.!time!>"!bat_camsdir!\Temp\autocams_busy.txt"
		REM start MonitorDir ... "!bat_camsdir!\Temp\RemoteSession_Busy.txt"
		REM 
	echo !bat_TempCalFromZipFull!> "!bat_camsdir!\Temp\autocams_busy.txt"
	
	if exist "!bat_camsdir!\Temp\RemoteSession_Busy.txt" (
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! `NOTICE: AutoCams menu options have been blocked while AutoCal_LocalDownload.bat
		!bat_echolog! `        runs. This is to avoid multiple instances of AutoCams from 
		!bat_echolog! `        interfering with each other.
		!bat_echolog! `        
		!bat_echolog! "waiting for Remote calibration to finish, do not close MonitorDir"
		
		CHOICE /T 10 /C CA /N /M "Do you want to [C]ontinue or [A]bort the wait?"
		if errorlevel equ 2 (
			del /q "!bat_camsdir!\Temp\RemoteSession_Busy.txt"
		) else (
			!bat_log! start "MonitorDir - [!bat_camsdir!\Temp\RemoteSession_Busy.txt]" /low /min /wait "!bat_camsdir!\MonitorDir.exe" /FilenameChange /Creation /DeletionClose /Activate "!bat_cams_root!\Temp" "!bat_camsdir!\Temp\RemoteSession_Busy.txt"
					  start "MonitorDir - [!bat_camsdir!\Temp\RemoteSession_Busy.txt]" /low /min /wait "!bat_camsdir!\MonitorDir.exe" /FilenameChange /Creation /DeletionClose /Activate "!bat_cams_root!\Temp" "!bat_camsdir!\Temp\RemoteSession_Busy.txt"
			!bat_echolog! "waiting for autocams finished"
		)
	) 

