  @echo off
setlocal enabledelayedexpansion enableextensions

	REM ###########################################################
	REM 

:CHECKHELP

	(echo.%*|findstr /L /i /c:"/?" >nul: 2>&1) && (goto :HELP)

	
	echo.
goto :SETUP


		
	
	
	REM ###########################################################
	REM 

:SETUP

call "%~dp0clear_bat_vars.bat"
set bat_TITLE_string= 
TITLE !bat_TITLE_string!

	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	!bat_CALL! "%~dp0ReadParams.bat"


	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! [%date% %time%] - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!

	!bat_CALL! "%~dp0ReadConfig.bat"

echo............
echo.!bat_call2! :TESTINGCALL asdf asdf  asdf asdf asdf 
!bat_call2! :TESTINGCALL asdf asdf  asdf asdf asdf 

goto :MAIN %*


	REM ###########################################################
	REM 

:MAIN
!bat_pushecho! [GOTO !bat_batchfile!:MAIN] [%*]


	set bat_commandline=%*
	
	if /i "%~1" equ "" (set bat_commandline=%*)


	!bat_echolog! 
	!bat_echolog! %~nx0 - Command Line:
	!bat_echolog! %*
	!bat_echolog! Starting command immediately after the following line [between the "vvvv" and "####"]
	!bat_echolog! vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
	              !bat_CALL! %*
	              set bat_returncode=%errorlevel%
	!bat_echolog! AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
	!bat_echolog! TestScript has returned from the called script
	!bat_echolog! [ERRORLEVEL=!bat_returncode!]
	!bat_echolog!
	!bat_echolog! 

!bat_pause! You can use enter batch commands to query variables now...

rem 	!bat_echolog!

:MAIN_END
!bat_popecho! [RETURN !bat_batchfile!:DONE] [ok]
!bat_echolog!
goto :DONE




	REM ###########################################################
	REM 

:HELP
	echo.
	echo.Usage: call "%~nx0"
	echo.
	echo.Forwards the command line to test sub-scripts by providing all the extra
	echo.indent and debugging infrastructure.  That way, it can simulate how the
	echo.subscripts are called by autocams.bat and other main scripts.
	echo.
	echo.This is especially useful for those scripts that you want to test, but they
	echo.don't stand alone, such as FTPhash.bat, GetCameraList.bat, ReadParams.bat, etc.
	echo.
	echo.Returns:
	echo.  nothing
	echo.
	echo.Example(s):
	echo.    %~f0 FTPhash test.zip
	echo.
	echo.After it calls the FTPhash script, the environment variables can be 
	echo.compared.
	echo.
exit /b -99



	REM ###########################################################
	REM 

:TESTINGCALL
echo.[CALL %~nx0:TESTINGCALL] 
	!bat_echolog! %1 %2 %3 %4 %5 %6
	!bat_logexec! dir *.txt

exit /b 0





	REM ###########################################################
	REM 

:DONE
!bat_popecho! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!bat_echolog! [DONE !bat_batchfile!:DONE]
!bat_echolog!
exit /b 0
