  @echo off
setlocal enabledelayedexpansion enableextensions


	REM #########################################################################
	REM 

:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

	REM #########################################################################
	REM 

:CHECKHELP_END
goto :SETUP %*

	Flowchart:

	New changes 09/21/2011:
		
	
	
:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	call "!bat_exedir!\ReadParams.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!

	set bat_caldir=!bat_camsdir!\Cal
	

	if "%~1" equ "" (
		goto :HELP
	)

	set bat_archivedfilesdir=%~1
	set bat_submissionfilesdir=%~2
	set bat_captureddate=%~3
	set bat_capturedtime=%~4
	set bat_camera=%~5

	call :MAIN "!bat_archivedfilesdir!"
goto :DONE





:MAIN
!bat_pushlog! [CALL !bat_batchfile!:MAIN] [%*]

	call "!bat_exedir!\RedirectLogs" "!bat_captureddate!_!bat_capturedtime!" "!bat_logdir!"

	set bat_retval=
	set bat_returncode=0
	
rem	set bat_archivedfilesdir_name=%~nx1
	CALL "!bat_exedir!\ParseDir.bat" "!bat_logdir!" "bat_basedir" "bat_logdir_name"
	CALL "!bat_exedir!\ParseDir.bat" "!bat_basedir!" "bat_basedir" "bat_basedir_name"

	!bat_logexeclog! set bat_targetdir=!bat_camsdir!\Temp\Logs\!bat_logdir_name!
	!bat_logexeclog! md "!bat_targetdir!"
	
	rem !bat_logexec! copy /y "!bat_logdir!\*.log" "!bat_targetdir!"
	
	CALL "!bat_exedir!\ParseDir.bat" "!bat_targetdir!" "bat_targetbase_dir" "bat_targetdir_name"

	!bat_logexeclog! set bat_zipfile=!bat_targetbase_dir!\logs_!bat_captureddate!_!bat_camera!_!bat_capturedtime!.zip
	!bat_logexeclog! set bat_zipsrc=!bat_logdir!\*.log
	
	!bat_echolog! Going to use the zip file: !bat_zipfile!
	!bat_echolog!
	
	if not exist "!bat_zipsrc!" (
		set bat_returncode=99
		set bat_recent_error_msg=ZipLogs. ERROR - Source dir does not exist ["!bat_zipsrc!"]
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
		goto :MAIN_END		
	)

	!bat_echolog! call "!bat_exedir!\7za.exe" a -r -tzip "!bat_zipfile!" "!bat_zipsrc!"
	              call "!bat_exedir!\7za.exe" a -r -tzip "!bat_zipfile!" "!bat_zipsrc!">"!bat_logdir!\7za.exe.log" 2>&1
	set bat_returncode=!bat_logexec_returncode!
	
	!bat_logexeclog! find /v ""  "!bat_logdir!\7za.exe.log"
	
	if !bat_returncode! neq 0 (
		set bat_recent_error_msg=ZipLogs.ERROR - Failed to create the zip file using: "!bat_exedir!\7za.exe" a -r -tzip "!bat_zipfile!" "!bat_zipsrc!"
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog! '    errorlevel=!bat_returncode!
		!bat_echolog!
		!bat_echolog! '    Deleting empty zip file...
		if defined bat_zipfile (
			!bat_logexec! del /q "!bat_zipfile!"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:MAIN] Dangerous command: del /q "!bat_zipfile!"
		)
		goto :MAIN_END		
	)
	
	if exist "!bat_zipfile!" (
			rem Test for empty zip file...
		call :FTPHASH "!bat_zipfile!"
		if /i "!bat_hash!" equ "76CDB2BAD9582D23C1F6F4D868218D6C" (
			set bat_returncode=3
			set bat_recent_error_msg=ZipLogs.ERROR - Empty zip file: "%~1" - deleting the zip file...
			!bat_echolog!
			!bat_echolog! '    !bat_recent_error_msg!
			!bat_echolog! '    errorlevel=!bat_returncode!
			!bat_echolog!
			if defined bat_zipfile (
				!bat_logexec! del /q "!bat_zipfile!"
			) else (
				!bat_echolog! ERROR [!bat_batchfile!:MAIN] Dangerous command: del /q "!bat_zipfile!"
			)
		) else (
			set bat_recent_error_msg=ZipLogs.SUCCESS - created "!bat_zipfile!"
			!bat_echolog!
			!bat_echolog!
			!bat_echolog! '    Not a blank zip file...
			!bat_echolog! '    !bat_recent_error_msg!
			!bat_echolog!
			!bat_echolog!
			set bat_retval=!bat_recent_error_msg!
		)
	)
	
	if /i "!bat_targetdir!" neq "" (
		for /f "usebackq tokens=*" %%a in (`dir "!bat_targetdir!\*.log" /s/b /on /a-d`) do (
			if /i "%%a" neq "" (
				!bat_logexeclog! del /q "%%a"
			) else (
				!bat_echolog! ERROR [!bat_batchfile!:MAIN] Dangerous command: del /s /q "%%a"
			)
		)
	)
	
	if /i "!bat_targetdir!" neq "" (
		for /f "usebackq tokens=*" %%a in (`dir "!bat_camsdir!\Temp\Logs" /s/b /on /ad`) do (
			if /i "%%a" neq "" (
				!bat_logexeclog! del /s /q "%%a"
				!bat_logexeclog! rd "%%a"
			) else (
				!bat_echolog! ERROR [!bat_batchfile!:MAIN] Dangerous command: del /s /q "%%a"
			)
		)
	)
	
	!bat_echolog!
	!bat_pushecho! The zip file containing the log files is:
	!bat_echolog! "!bat_zipfile!"
	!bat_echolog!

:MAIN_END
!bat_poplog! [RETURN !bat_batchfile!:MAIN] [!bat_retval!]
!bat_log!
!bat_return!





	rem Do an MD5 hash of the zip file for comparison
:FTPHASH
!bat_pushlog! [CALL !bat_batchfile!:FTPHASH] %*
	set bat_retval=
	set bat_hash=

	if not exist "%~1" (
		set bat_retval=1
		goto :FTPHASH_END
	)

	!bat_logexeclog! call md5 -o"!bat_camsdir!\Logs\md5.output.log" "%~1"
	set bat_retval=!bat_logexec_returncode!
	
	if !bat_retval! equ 0 (
		for /f "usebackq tokens=1,*" %%X in ("!bat_camsdir!\Logs\md5.output.log") do (
			set bat_hash=%%X
		)
		
		if not defined bat_RetVal1 (
			set bat_retval=3
		)
	)
	
	if exist "!bat_camsdir!\Logs\md5.output.log" (
		if /i "!bat_camsdir!" neq "" (
			!bat_logexeclog! del /q "!bat_camsdir!\Logs\md5.output.log"
		)
	)
	
:FTPHASH_END
!bat_poplog! [RETURN !bat_batchfile!:FTPHASH] [bat_retval=!bat_retval!, bat_hash=!bat_hash!]
!bat_log!
!bat_return!





:READPARAMS
!bat_pushlog! [CALL !bat_batchfile!:READPARAMS] %*
	!bat_echolog! call "!bat_exedir!\ReadParams.bat"
				  CALL "!bat_exedir!\ReadParams.bat"
:READPARAMS_END
!bat_poplog! [RETURN !bat_batchfile!:READPARAMS] [!bat_paramsfile!=!bat_retval!]
!bat_log!
!bat_return!









:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 "!bat_archivedfilesdir!"
	echo.
	echo Creates a zip file of the log files in the ArchivedFiles dir as well as
	echo the log files in the ..\Logs dir.
	echo.
exit /b -99



:DONE
!bat_poplog! :DONE with %~f0 %*
!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	ENDLOCAL & IF "%BAT_RETVAL%" NEQ "" (
		SET bat_retval=%bat_retval%
	) ELSE ( echo.%bat_retval%)
exit /b 0