
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''    START OF LOGIC                                          '''''
''''                                                            '''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''


	pi = 3.1415926535897932384626433832795

	yearin = (WScript.Arguments.Item(0))
	monthin = (WScript.Arguments.Item(1))
	dayin = (WScript.Arguments.Item(2))


	'Reading parameters from Autocams.Params.ini and camerasites.txt

	Dim a
	Dim strLine
	Dim objFSO 
	dim curDir
	dim WinScriptHost


	Set dateTime = CreateObject("WbemScripting.SWbemDateTime")
	
	Set objFSO = CreateObject("Scripting.FileSystemObject")

	Const wbemCimTypeDatetime = 101
	Const ForAppending = 8
	Const ForReading = 1
	Const ForWriting = 2

	curDir = objFSO.GetAbsolutePathName(".")

	Set objFile= objFSO.OpenTextFile(curDir&"\AutoCams.Params.ini", ForReading)

	Set myLog = objFSO.OpenTextFile(curDir&"\logs\dusk.vbs.log",ForAppending, True)

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''' Steve, would it be possible to set the TimeUTcurrent value 
'''' here and use it everywhere else in the program (including the
'''' header below?
'''' ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	dateTime.SetVarDate(Now())

	
	myLog.WriteLine()
	myLog.WriteLine ("-----------------------------------------------------------------------------------------")
	myLog.WriteLine ("Executed: TimeUTcurrent="&dateTime.GetVarDate(true) & " Local, " & dateTime.GetVarDate(false) & " UTC")
	myLog.WriteLine ("Command-line Arguments: Yearin="& Yearin & " monthin="& monthin & " dayin=" & dayin)


	myLog.WriteLine ("curDir : "&curDir)


		' Read the Autocams.Params.ini file into variables...
	Do While Not objFile.AtEndOfStream
		strLine = objFile.readline
		If InStr(strLine, "//") = 0 Then
			If InStr(strLine, "[") = 0 Then
				If InStr(strLine,"=")>1 then
					var=Trim(Left(strLine,InStr(strLine,"=")-1))
					var=section&"_"&var
					var=Replace(var,".","_")
					value=Trim(Right(strline,Len(strLine)-InStr(strLine,"=")))

					Select Case var
						Case "CAPTURE_sunangle_dusk"
							ValStr=Value
							If InStr(ValStr,".")>0 then
								sunangle_dusk_Str=Trim(Left(ValStr,InStr(ValStr,".")-1))&"A"&Trim(Right(ValStr,Len(ValStr)-InStr(ValStr,".")))
							Else
								sunangle_dusk_Str=ValStr
							End if

							myLog.WriteLine ("CAPTURE_sunangle_dusk : "&sunangle_dusk_Str)

						Case "CAPTURE_sunangle_dawn"
							ValStr=Value
							If InStr(ValStr,".")>0 then
								sunangle_dawn_Str=Trim(Left(ValStr,InStr(ValStr,".")-1))&"A"&Trim(Right(ValStr,Len(ValStr)-InStr(ValStr,".")))
							Else
								sunangle_dawn_Str=ValStr
							End if

							myLog.WriteLine ("CAPTURE_sunangle_dawn : "&sunangle_dawn_Str)

						Case "CAPTURE_cameralist"
							CameraList=value  
							myLog.WriteLine ("CameraList : "&CameraList)
						Case "LOCALIZE_separator_decimal"
							seperator_decimal=value  
							myLog.WriteLine ("seperator_decimal : "&seperator_decimal)
					End Select
				End If 
			End If 
		End if 

		If InStr(strLine, "//") = 0 Then
			If InStr(strLine, "[") = 1 Then    
				section=strLine
				section=Replace(section,"[","")
				section=Replace(section,"]","")      
			End If 
		End if 
	Loop

	objFile.Close



	If InStr(sunangle_dusk_Str,"A")>0 then
		sunangle_dusk=Trim(Left(sunangle_dusk_Str,InStr(sunangle_dusk_Str,"A")-1))&seperator_decimal&Trim(Right(sunangle_dusk_Str,Len(sunangle_dusk_Str)-InStr(sunangle_dusk_Str,"A")))
	Else
		sunangle_dusk=CDbl(sunangle_dusk_Str)
	End If

	sunangle_dusk=(-1)*sunangle_dusk
	myLog.WriteLine ("CAPTURE_sunangle_dusk : "&sunangle_dusk)
	
	If InStr(sunangle_dawn_Str,"A")>0 then
		sunangle_dawn=Trim(Left(sunangle_dawn_Str,InStr(sunangle_dawn_Str,"A")-1))&seperator_decimal&Trim(Right(sunangle_dawn_Str,Len(sunangle_dawn_Str)-InStr(sunangle_dawn_Str,"A")))
	Else
		sunangle_dawn=CDbl(sunangle_dawn_Str)
	End If

	sunangle_dawn=(-1)*sunangle_dawn
	myLog.WriteLine ("CAPTURE_sunangle_dawn : "&sunangle_dawn)



'end of reading parameters 



	Camera = CameraList
	
	If InStr(Camera," ")>1 then
		Camera=Trim(Left(Cameralist,InStr(Cameralist," ")))
	End If 
	
	myLog.WriteLine ("Camera : "&Camera)
	Set objFile= objFSO.OpenTextFile(curDir&"\CAL\camerasites.txt", 1)

	Do While Not objFile.AtEndOfStream
		strLine = objFile.readline
		
		If InStr(strLine,Camera)=1 Then
			strLine=Trim(Right(strline,Len(strLine)-InStr(strLine," ")))      
			latStr=Trim(Left(strline,InStr(strline," ")-1))
			latStr=Trim(Left(latStr,InStr(latStr,".")-1))&seperator_decimal&Trim(Right(latStr,Len(latStr)-InStr(latStr,".")))
			lat=CDbl(latStr)

			strLine=Trim(Right(strline,Len(strLine)-InStr(strLine," ")))
			lonStr=Trim(Left(strline,InStr(strline," ")-1))
			lonStr=Trim(Left(lonStr,InStr(lonStr,".")-1))&seperator_decimal&Trim(Right(lonStr,Len(lonStr)-InStr(lonStr,".")))
			lon=(-1)*CDbl(lonStr)

		End If 
	Loop 
	
	myLog.WriteLine ("lat : "&lat)
	myLog.WriteLine ("lon : "&lon)

	objFile.Close
	
	
	nextDay=false 
	myLog.WriteLine ("nextDay : "&nextDay)
	TimeUTon = dusk(lat, lon, yearin, monthin, dayin, 0, 0, sunangle_dusk)

	myLog.WriteLine ("TimeUTon : "&TimeUTon)
	
		' If timeUTon is on next day: change date and adjust Time
	If TimeUTon > 1 Then 
		TimeUTon=TimeUTon-1 
		myLog.WriteLine ("TimeUTon : "&TimeUTon)
		tempdate=DateSerial(yearin,monthin,dayin)
		tempdate=DateAdd("d",1,tempdate)
		yearin=Year(tempDate)
		monthin=Month(tempdate)
		dayin=Day(tempdate)
		nextDay=True
		myLog.WriteLine ("nextDAy : "&nextDay)
	End If
	
	
	CameraOn=toHMS(TimeUTon)
	myLog.WriteLine ("CameraOn : "&CameraOn)
	Test=DateSerial(yearin,monthin,dayin)
	dateTime.SetVarDate CDate(FormatDateTime(test,2)&" "&CameraOn),False
	TimeUTon=CDate(dateTime.GetVarDate (false))
	myLog.WriteLine ("TimeUTon : "&TimeUTon)

	TimeLocalon=CDate(dateTime.GetVarDate ())
	myLog.WriteLine ("TimeLocalOn : "&TimeLocalon)
	Offset1=Round((timelocalon-TimeUTon)*24,2)
	If Offset1 > 0 Then Offset1="+"&Offset1
	myLog.WriteLine ("Offset1 : "&Offset1)

	'go to prev day if gone to next day in TimeUTon (perhaps starting late)
	If  nextday then
		tempdate=DateSerial(yearin,monthin,dayin)
		tempdate=DateAdd("d",-1,tempdate)
		yearin=Year(tempDate)
		monthin=Month(tempdate)
		dayin=Day(tempdate)
		nextday=false
		myLog.WriteLine ("nextDAy : "&nextDay)
	End if

	TimeUTOff = dawn(lat, lon, yearin, monthin, dayin, 0, 0, sunangle_dawn)
	myLog.WriteLine ("TimeUToff : "&TimeUToff)

	If TimeUToff > 1 Then
		TimeUToff=TimeUToff-1
		tempdate=DateSerial(yearin,monthin,dayin)
		tempdate=DateAdd("d",1,tempdate)
		yearin=Year(tempDate)
		monthin=Month(tempdate)
		dayin=Day(tempdate)
		nextday=true
	End If 
	
	myLog.WriteLine ("TimeUToff : "&TimeUToff)

	If TimeUToff < 0 Then
		TimeUToff=TimeUToff+1
		tempdate=DateSerial(yearin,monthin,dayin)
		tempdate=DateAdd("d",-1,tempdate)
		yearin=Year(tempDate)
		monthin=Month(tempdate)
		dayin=Day(tempdate)
	End If 
	
	myLog.WriteLine ("TimeUToff : "&TimeUToff)

	CameraOff=toHMS(TimeUTOff)
	myLog.WriteLine ("CameraOff : "&CameraOff)

	Test=DateSerial(yearin,monthin,dayin)
	dateTime.SetVarDate CDate(FormatDateTime(test,2)&" "&CameraOff),False
	TimeUToff=CDate(dateTime.GetVarDate (false))
	myLog.WriteLine ("TimeUToff : "&TimeUToff)

	TimeLocaloff=CDate(dateTime.GetVarDate ())
	myLog.WriteLine ("TimeLocalOff : "&TimeLocalOff)
	
	dateTime.SetVarDate CDate(Now)
	TimeUTcurrent=CDate(dateTime.GetVarDate (false))
	TimeLocalcurrent=CDate(dateTime.GetVarDate ())
	myLog.WriteLine ("TimeUTcurrent = "&TimeUTcurrent)
	myLog.WriteLine ("TimeLocalcurrent = "&TimeLocalcurrent)
	
		' Get the localized name of the weekday
	NumDayLocal=DatePart("y", TimeLocalCurrent)
	WeekdayLocal=WeekdayName( Weekday(TimeLocalCurrent ))

	
	If (((TimeLocalOff - TimeLocalcurrent < 0) Or  (TimeLocalOff - TimeLocalcurrent > 1) or (TimeLocalOn - TimeLocalcurrent > 1)) And (TimeLocalOff-TimeLocalon < 0)) Then
			''' Calculates times for the next day...
		'late=true
		tempdate=DateSerial(yearin,monthin,dayin)
		tempdate=DateAdd("d",1,tempdate)
		yearin=Year(tempDate)
		monthin=Month(tempdate)
		dayin=Day(tempdate)
		myLog.WriteLine ("nextDAy : "&nextDay)
		TimeUTOff = dawn(lat, lon, yearin, monthin, dayin, 0, 0, sunangle_dawn)
		myLog.WriteLine ("TimeUToff next day : "&TimeUToff)
		CameraOff=toHMS(TimeUTOff)
		myLog.WriteLine ("CameraOff : "&CameraOff)

		Test=DateSerial(yearin,monthin,dayin)
		dateTime.SetVarDate CDate(FormatDateTime(test,2)&" "&CameraOff),False
		TimeUToff=CDate(dateTime.GetVarDate (false))
		myLog.WriteLine ("TimeUToff next day : "&TimeUToff)

		TimeLocaloff=CDate(dateTime.GetVarDate ())
		myLog.WriteLine ("TimeLocalOff next day : "&TimeLocalOff)
    Else
		TimeLocalOn = TimeLocalcurrent
		myLog.WriteLine ("TimeLocalOn Starting Late: "&TimeLocalOn)
		TimeUTon = TimeUTcurrent
		myLog.WriteLine ("TimeUTon Starting Late: "&TimeUTon)
	End If 

	Offset2=Round((timelocaloff-TimeUToff)*24,2)
	If Offset2 > 0 Then Offset2="+"&Offset2
	myLog.WriteLine ("Offset2 : "&Offset2)

	Duration=TimeUToff-TimeUTon
	myLog.WriteLine ("Duration : "&Duration)


	If Len(yearin) =1 Then yearin ="0"&CInt(yearin)
	If Len(monthin) =1 Then monthin = "0"&CInt(monthin)
	If Len(dayin) =1 Then dayin="0"&CInt(dayin)
	
	h=Hour(TimeUToff)
	If h < 10 Then h= "0"&h
	
	m=Minute(TimeUToff)
	If m < 10 Then m="0"&m
	
	s=Second(TimeUToff)
	If s < 10 Then s="0"&s

	TimeUToffString=yearin&"/"&monthin&"/"&dayin&" "&h&":"&m&":"&s

	myLog.WriteLine ("TimeUToffString = "&TimeUToffString)

	If lat>=0 Then 
		monthin = 12
	Else 
		monthin = 6
	End If 

	TempEOn=dusk(lat, lon, yearin, monthin, 11, 0, 0, sunangle_dusk)
	myLog.WriteLine (Yearin&"/"&monthin&"/11 TempEon = "&TempEon)
	
	If TempEOn > 1 Then
		TempEOn=TempEOn-1
	End If 
	
	If tempeon < 0 Then tempeon=TempEon+1
	
	myLog.WriteLine (Yearin&"/"&monthin&"/11 TempEon = "&TempEon)

	TempOff = dawn(lat, lon, yearin, monthin, 11, 0, 0, sunangle_dawn)
	myLog.WriteLine (Yearin&"/"&monthin&"/11 TempOff = "&TempOff)
	
	If TempOff > 1 Then
		TempOff=TempOff-1
	End If
	
	If tempOff<0 Then tempoff=TempOff+1
	
	myLog.WriteLine (Yearin&"/"&monthin&"/11 TempOff = "&TempOff)

	LatestOff=toHMS(TempOff)
	Test=DateSerial(yearin,monthin,11)
	dateTime.SetVarDate CDate(FormatDateTime(test,2)&" "&LatestOff),False
	LatestOff=CDate(dateTime.GetVarDate (false))-Test
	LatestOffLocal=CDate(dateTime.GetVarDate ())-Test
	
	If LatestOffLocal < 0 Then LatestOffLocal=LatestOffLocal+1
	If LatestOffLocal > 1 Then LatestOffLocal=LatestOffLocal-1


	TempOffLocal=LatestOffLocal
	myLog.WriteLine (Yearin&"/"&monthin&"/11 LatestOffLocal = "&LatestOffLocal)
	myLog.WriteLine (Yearin&"/"&monthin&"/11 TempOffLocal = "&TempOffLocal)

	EarlyOn=toHMS(TempEon)
	Test=DateSerial(yearin,monthin,11)
	dateTime.SetVarDate CDate(FormatDateTime(test,2)&" "&EarlyOn),False
	EarlyOn=CDate(dateTime.GetVarDate (false))-Test
	EarlyOnLocal=CDate(dateTime.GetVarDate ())-Test
	If EarlyOnLocal < 0 Then EarlyOnLocal=EarlyOnLocal+1
	If EarlyOnLocal > 1 Then EarlyOnLocal=EarlyOnLocal-1  


	TempEonLocal=EarlyOnlocal

	myLog.WriteLine (Yearin&"/"&monthin&"/11 EarlyOnlocal = "&EarlyOnlocal)
	myLog.WriteLine (Yearin&"/"&monthin&"/11 TempEonLocal = "&TempEonLocal)


	TempEOn=dusk(lat, lon, yearin, monthin, 31, 0, 0, sunangle_dusk)
	myLog.WriteLine (Yearin&"/"&monthin&"/31 TempEon = "&TempEon)
	
	If TempEOn > 1 Then
		TempEOn=TempEOn-1
	End If 
	
	If tempeon < 0 Then tempeon=tempeon+1
	myLog.WriteLine (Yearin&"/"&monthin&"/31 TempEon = "&TempEon)

	TempOff = dawn(lat, lon, yearin, monthin, 31, 0, 0, sunangle_dawn)
	myLog.WriteLine (Yearin&"/"&monthin&"/31 TempOff = "&TempOff)
	
	If TempOff > 1 Then
		TempOff=TempOff-1
	End If
	
	If tempOff<0 Then tempoff=tempoff+1
	
	myLog.WriteLine (Yearin&"/"&monthin&"/31 TempOff = "&TempOff)

	LatestOff=toHMS(TempOff)
	Test=DateSerial(yearin,monthin,31)
	dateTime.SetVarDate CDate(FormatDateTime(test,2)&" "&LatestOff),False
	LatestOff=CDate(dateTime.GetVarDate (false))-Test
	LatestOffLocal=CDate(dateTime.GetVarDate ())-Test
	
	If LatestOffLocal < 0 Then LatestOffLocal=LatestOffLocal+1
	If LatestOffLocal > 1 Then LatestOffLocal=LatestOffLocal-1  
  
	If TempOffLocal < LatestOffLocal Then
		TempOffLocal=LatestOffLocal
	End If 
	
	myLog.WriteLine (Yearin&"/"&monthin&"/31 LatestOffLocal = "&LatestOffLocal)
	myLog.WriteLine (Yearin&"/"&monthin&"/31 TempOffLocal = "&TempOffLocal)



	EarlyOn=toHMS(TempEon)
	Test=DateSerial(yearin,monthin,31)
	dateTime.SetVarDate CDate(FormatDateTime(test,2)&" "&EarlyOn),False
	EarlyOn=CDate(dateTime.GetVarDate (false))-Test
	EarlyOnLocal=CDate(dateTime.GetVarDate ())-Test
	
	If EarlyOnLocal < 0 Then EarlyOnLocal=EarlyOnLocal+1
	If EarlyOnLocal > 1 Then EarlyOnLocal=EarlyOnLocal-1  
  
	If TempEonLocal > EarlyOnLocal Then
		TempEonLocal=EarlyOnlocal
	End If 

	myLog.WriteLine (Yearin&"/"&monthin&"/31 EarlyOnlocal = "&EarlyOnlocal)
	myLog.WriteLine (Yearin&"/"&monthin&"/31 TempEonLocal = "&TempEonLocal)

	EarlyOnLocal=(Round(TempEOnLocal*24*2,0)-1)/(24*2)

	LatestOffLocal=(Round(TempOffLocal*24*2,0)+1)/(24*2)

	myLog.WriteLine ("Final EarlyOnlocal = "&EarlyOnlocal)
	myLog.WriteLine ("Final LatestOffLocal = "&LatestOffLocal)


	EarlyOnLocal=toHMS(EarlyOnLocal)
	LatestOffLocal=toHMS(LatestOffLocal)
	myLog.WriteLine ("Final EarlyOnlocal = "&EarlyOnlocal)
	myLog.WriteLine ("Final LatestOffLocal = "&LatestOffLocal)


	If TempEOnLocal < TempOffLocal Then
		EarlyOnLocal = "Always ON"
		LatestOffLocal= "Always ON"
	End If 

	myLog.WriteLine ("(Always ON ?) Final EarlyOnlocal = "&EarlyOnlocal)
	myLog.WriteLine ("(Always ON ?) Final LatestOffLocal = "&LatestOffLocal)





	If Duration >0.99 Then
		Duration=0.99
		EarlyOnLocal="Always ON"
		LatestOffLocal="Always ON"
	End If

''''''''' Added by Dave Samuels...'''''''''''''''''''''''''''''''''''
''' Watch out for running this for a different date.  For example, if 
''' you ran this on 2014-12-08 for 2014-12-01, the Duration variable 
''' becomes too large. 
	If (TimeUToff - TimeUTCurrent > 0) And ((Duration > TimeUToff - TimeUTCurrent) Or (Duration < 0)) Then
		Duration = TimeUToff - TimeUTCurrent
		myLog.WriteLine ("Duration change due to late start = "&Duration&", or "&Duration*24 & " hours")
                TimeLocalOn = TimeLocalcurrent
		myLog.WriteLine ("TimeLocalOn Starting Late: "&TimeLocalOn)
		TimeUTon = TimeUTcurrent
		myLog.WriteLine ("TimeUTon Starting Late: "&TimeUTon)
	End If
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

'	If (TimeUTcurrent > TimeUTon) And (TimeUTcurrent < TimeUToff) Then
'		Duration=TimeUToff-TimeUTcurrent
'		myLog.WriteLine ("Duration changed current time = "&Duration)
'	End If
'	
'	If (TimeUTcurrent > TimeUTon-1) And (TimeUTcurrent < TimeUToff) Then
'		Duration=TimeUToff-TimeUTcurrent
'		myLog.WriteLine ("Duration changed current time = "&Duration)
'	End If

    yearin=Year(TimeUTCurrent)
    monthin=Month(TimeUTCurrent)
    Dayin=Day(TimeUTCurrent)

	If Len(yearin) =1 Then yearin ="0"&CInt(yearin)
	If Len(monthin) =1 Then monthin = "0"&CInt(monthin)
	If Len(dayin) =1 Then dayin="0"&CInt(dayin)

	h=Hour(TimeUTCurrent)
	If h < 10 Then h= "0"&h
	
	m=Minute(TimeUTCurrent)
	If m < 10 Then m="0"&m
	
	s=Second(TimeUTCurrent)
	If s < 10 Then s="0"&s
	
	TimeUTCurrentString=yearin&"/"&monthin&"/"&dayin&" "&h&":"&m&":"&s
	
	myLog.WriteLine ("TimeUTCurrentString = "&TimeUTCurrentString)
	
	yearin=Year(TimeUTon)
    monthin=Month(TimeUTon)
    Dayin=Day(TimeUTon)
	
	If Len(yearin) =1 Then yearin ="0"&CInt(yearin)
	If Len(monthin) =1 Then monthin = "0"&CInt(monthin)
	If Len(dayin) =1 Then dayin="0"&CInt(dayin)

	h=Hour(TimeUTon)
	If h < 10 Then h= "0"&h
	
	m=Minute(TimeUTon)
	If m < 10 Then m="0"&m
	
	s=Second(TimeUTon)
	If s < 10 Then s="0"&s
	
	Datum=DateValue(TimeUTon)
	TimeUTonString=yearin&"/"&monthin&"/"&dayin&" "&h&":"&m&":"&s

	myLog.WriteLine ("TimeUTonString = "&TimeUTonString)
	
	StartDelay=TimeUTon-TimeUTcurrent
	If TimeUToff < TimeUTon Then startdelay=0
	myLog.WriteLine ("StartDelay = "&StartDelay)
	
	If (StartDelay<0) Or (StartDelay > 1) Then StartDelay=0
	myLog.WriteLine ("StartDelay = "&StartDelay)
	
	StartDelaySec=Round(24*60*60*StartDelay)
	myLog.WriteLine ("StartDelay = "&StartDelay)
	
	UurDuration=Round(Duration*24,2)
	myLog.WriteLine ("UurDuration = "&UurDuration)
	
	DurationSec=Uurduration*3600
	myLog.WriteLine ("DurationSec = "&DurationSec)


	num_str = cstr(UurDuration)
	
		' compute the length of string
	comma_pos = instr(num_str,",")

	if point_pos > 0 then
			'if number contains decimal point
		Uurduration_str=Uurduration
		new_length = point_pos + decimals
	elseif comma_pos > 0 then
			'if number contains decimal comma
		Uurduration_str=Replace(num_str,",",".")
		new_length = comma_pos + decimals
	else
			'if number doen't contain point nor comma
		Uurduration_str=Uurduration
		new_length = length
	end If

	lat=lat
	lon=(-1)*lon

	myLog.WriteLine ("Uurduration_str = "&Uurduration_str)  
	myLog.WriteLine ("Output :"&TimeUTonString&";"&TimeLocalon&";"&Offset1&";"&TimeUToffString&";"&TimeLocaloff&";"&Offset2&";"&Uurduration_str&";"&DurationSec&";"&TimeUTCurrentString&";"&TimeLocalcurrent&";"&StartDelaySec&";"&EarlyOnLocal&";"&LatestOffLocal&";"&Camera&";"&lat&";"&lon)
	
	myLog.Close

	wscript.Echo (TimeUTonString&";"&TimeLocalon&";"&Offset1&";"&TimeUToffString&";"&TimeLocaloff&";"&Offset2&";"&Uurduration_str&";"&DurationSec&";"&TimeUTCurrentString&";"&TimeLocalcurrent&";"&StartDelaySec&";"&EarlyOnLocal&";"&LatestOffLocal&";"&Camera&";"&lat&";"&lon&";"&WeekdayLocal)



'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''                                                           '''''
''''                END OF PROGRAM LOGIC                        '''''
''''                                                            '''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''




' Calculation of local times of sunrise, solar noon, and sunset
' based on the calculation procedure by NOAA in the javascript in
' http://www.srrb.noaa.gov/highlights/sunrise/sunrise.html and
' http://www.srrb.noaa.gov/highlights/sunrise/azel.html
'
' Five functions are available for use from Excel worksheets:
'
'   - sunrise(lat, lon, year, month, day, timezone, dlstime)
'   - solarnoon(lat, lon, year, month, day, timezone, dlstime)
'   - sunset(lat, lon, year, month, day, timezone, dlstime)
'   - solarazimuth(lat, lon, year, month, day, hour, minute, second, timezone, dlstime)
'   - solarelevation(lat, lon, year, month, day, hour, minute, second, timezone, dlstime)
'
' The sign convention for inputs to the functions named sunrise, solarnoon,
' sunset, solarazimuth, and solarelevationis:
'
'   - positive latitude decimal degrees for northern hemisphere
'   - negative longitude degrees for western hemisphere
'   - negative time zone hours for western hemisphere
'
' The other functions in the VBA module use the original
' NOAA sign convention of positive longitude in the western hemisphere.
'
' The calculations in the NOAA Sunrise/Sunset and Solar Position
' Calculators are based on equations from Astronomical Algorithms,
' by Jean Meeus. NOAA also included atmospheric refraction effects.
' The sunrise and sunset results were reported by NOAA
' to be accurate to within +/- 1 minute for locations between +/- 72°
' latitude, and within ten minutes outside of those latitudes.
'
' This translation was tested for selected locations
' and found to provide results within +/- 1 minute of the
' original Javascript code.
'
' This translation does not include calculation of prior or next
' susets for locations above the Arctic Circle and below the
' Antarctic Circle, when a sunrise or sunset does not occur.
'
' Translated from NOAA's Javascript to Excel VBA by:
'
' Greg Pelletier
' Department of Ecology
' P.O.Box 47600
' Olympia, WA 98504-7600
' email: gpel461@ ecy.wa.gov





'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''    START OF FUNCTIONS                                      '''''
''''                                                            '''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''


'Define trigoniometric functions not provided in VBS




	'***********************************************************************/
	'* Name:    atan2
	'* Type:    Function
	'* Purpose: Compute arc tangent with two parameters. 
	'* Arguments:
	'*   ys
	'*   xs
	'* Return value:
	'*   The angle in radians.
	'***********************************************************************/
	
Function atan2(ys, xs) 

	Dim theta 

	If xs <> 0 Then 
		theta = Atn(ys / xs) 
		
		If xs < 0 Then 
			theta = theta + pi 
		End If 
		
	Else 
		If ys < 0 Then 
			theta = 3 * pi / 2 '90 
		Else 
			theta = pi / 2 '270 
		End If 
	End If 
	
	atan2 = theta 
	
End Function 




	'***********************************************************************/
	'* Name:    toHMS
	'* Type:    Function
	'* Purpose: Convert the given Excel formatted time into HH:MM:SS format. 
	'* Arguments:
	'*   tijdExcell     Which is an Excel type of time as a percentage of a day. 
	'* Return value:
	'*   String containing the time in "HH:MM:SS" format.
	'***********************************************************************/
	
Function toHMS(TimeIn)


    tijdExcell = TimeIn
	Uur=cInt(tijdExcell*24)
	tijdExcell=tijdExcell*24-Uur
	
	If tijdExcell < 0 Then
		tijdExcell=tijdExcell+1
		Uur=Uur-1
	End if
	
	Min=CInt(tijdExcell*60)
	tijdExcell=tijdexcell*60-Min
	
	If tijdExcell < 0 Then
		tijdExcell=tijdExcell+1
		Min=Min-1
	End if
	
	Sec=cInt(tijdExcell*60)
	If sec > 59 Then Sec = 59
	
	If Uur < 10 Then
	   Uur="0"&Uur
	End If	
	
	If Sec < 10 Then
		Sec="0"&Sec
	End If
	
	If Min <10 Then
		Min="0"&Min
	End If
	
	toHMS=Uur&":"&Min&":"&Sec

End Function




	'***********************************************************************/
	'* Name:    nowExcell
	'* Type:    Function
	'* Purpose: Get the current time in Excel format. The Excel format uses
	'*          time as a percentage of the whole day.  
	'* Arguments:
	'*   none
	'* Return value:
	'*   Current time as a percentage of the day. 
	'***********************************************************************/
	
Function nowExcell

	Nu=(Hour(Now())/24)+(Minute(Now())/(24*60))+(Second(Now())/(24*60*60))
	nowExcell=Nu

End Function



	'***********************************************************************/
	'* Name:    Asin
	'* Type:    Function
	'* Purpose: arc sine
	'* Arguments:
	'*   X
	'* Return value:
	'*   Inverse Sine of X. 
	'***********************************************************************/
	
Function Asin(X)

	If X = 1 Then  
		Asin = PI / 2  
	ElseIf X = -1 Then  
		Asin = -PI / 2  
	Else  
		Asin = Atn(X / Sqr(-X * X + 1))  
	End If  

End Function



	'***********************************************************************/
	'* Name:    ACos
	'* Type:    Function
	'* Purpose: arc cosine
	'* Arguments:
	'*   number
	'* Return value:
	'*   The arc cosine of the number. 
	'* Notes:
	'*   error if NUMBER is outside the range [-1,1]
	'***********************************************************************/
	
Function ACos(ByVal number)

	If number > 1 Then
		number=1
	End If
	
	If number < -1 Then 
		number = -1
	End if
	
	If Abs(number) <> 1 Then
		ACos = 1.5707963267949 - Atn(number / Sqr(1 - number * number))
	End If 
	
	If number = -1 Then
		ACos = 3.14159265358979
	End If
	
	If number = 1 Then 
		ACos=0
	End if
	
End Function



	'***********************************************************************/
	'* Name:    truncate
	'* Type:    Function
	'* Purpose: Converts a number to a smaller number by
	'*          truncating some of the decimals.
	'* Arguments:
	'*   num
	'*   decimals
	'* Return value:
	'*   double of the number 
	'***********************************************************************/
	
Function truncate(num, decimals)

		' convert to string
	num_str = cstr(num)
	
		' compute the length of string
	length = len(num_str)

	point_pos = instr(num_str,".")
	comma_pos = instr(num_str,",")
	'wscript.echo "point_pos = " & point_pos
	'wscript.echo "comma_pos = " & comma_pos

	if point_pos > 0 then
		'if number contains decimal point
		new_length = point_pos + decimals
	elseif comma_pos > 0 then
		'if number contains decimal comma
		new_length = comma_pos + decimals
	else
		'if number doen't contain point nor comma
		new_length = length
	end if

	new_num_str = left(num_str, new_length)

	'convert to double
	truncate = cdbl(new_num_str)
end Function



	'***********************************************************************/
	'* Name:    transform
	'* Type:    Function
	'* Purpose: Converts number to a double??? not sure, However, it seems
	'*          that the cInt() function call at the end seems to indicate
	'*          that this function transforms a number into an Int.
	'* Arguments:
	'*   num
	'* Return value:
	'*   Integer of the number 
	'***********************************************************************/

Function transform(num)

		' convert to string
	num_str = cstr(num)
	
		' compute the length of string
	length = len(num_str)

	point_pos = instr(num_str,".")
	comma_pos = instr(num_str,",")
	'wscript.echo "point_pos = " & point_pos
	'wscript.echo "comma_pos = " & comma_pos


	new_length = length

	new_num_str = left(num_str, new_length)

		'convert to Int
	transform = CInt(new_num_str)
end Function



	'***********************************************************************/
	'* Name:    radToDeg
	'* Type:    Function
	'* Purpose: Convert radian angle to degrees
	'* Arguments:
	'*   angleRad
	'* Return value:
	'*   The angle in degrees 
	'***********************************************************************/

Function radToDeg(angleRad)

        radToDeg = (180 * angleRad / Pi)

End Function



	'***********************************************************************/
	'* Name:    degToRad
	'* Type:    Function
	'* Purpose: Convert degree angle to radians
	'* Arguments:
	'*   angleDeg
	'* Return value:
	'*   The Radian of the angle
	'***********************************************************************/

Function degToRad(angleDeg)

		degToRad = (pi * angleDeg / 180)

End Function



	'***********************************************************************/
	'* Name:    calcJD
	'* Type:    Function
	'* Purpose: Julian day from calendar day
	'* Arguments:
	'*   year : 4 digit year
	'*   month: January = 1
	'*   day  : 1 - 31
	'* Return value:
	'*   The Julian day corresponding to the date
	'* Note:
	'*   Number is returned for start of day.  Fractional days should be
	'*   added later.
	'***********************************************************************/

Function calcJD(yearin, monthin, dayin)

	Dim A, B, JD

	If (monthin <= 2) Then
		yearin = yearin - 1
		monthin = monthin + 12
	End If

	A = truncate(yearin / 100,0)
	B = 2 - A + truncate(A / 4,0)

	JD = truncate(365.25 * (yearin + 4716), 0) + _
	     truncate(30.6001 * (monthin + 1), 0) + dayin + B - 1524.5
	calcJD = JD

		'gp put the year and month back where they belong
	If monthin = 13 Then
		monthin = 1
		yearin = yearin + 1
	End If
	
	If monthin = 14 Then
		monthin = 2
		yearin = yearin + 1
	End If

End Function



	'***********************************************************************/
	'* Name:    calcTimeJulianCent
	'* Type:    Function
	'* Purpose: convert Julian Day to centuries since J2000.0.
	'* Arguments:
	'*   jd : the Julian Day to convert
	'* Return value:
	'*   the T value corresponding to the Julian Day
	'***********************************************************************/

Function calcTimeJulianCent(JD)

	Dim t

	t = (JD - 2451545) / 36525
	calcTimeJulianCent = t

End Function



	'***********************************************************************/
	'* Name:    calcJDFromJulianCent
	'* Type:    Function
	'* Purpose: convert centuries since J2000.0 to Julian Day.
	'* Arguments:
	'*   t : number of Julian centuries since J2000.0
	'* Return value:
	'*   the Julian Day corresponding to the t value
	'***********************************************************************/

Function calcJDFromJulianCent(t)

	Dim JD

	JD = t * 36525 + 2451545
	calcJDFromJulianCent = JD

End Function



	'***********************************************************************/
	'* Name:    calGeomMeanLongSun
	'* Type:    Function
	'* Purpose: calculate the Geometric Mean Longitude of the Sun
	'* Arguments:
	'*   t : number of Julian centuries since J2000.0
	'* Return value:
	'*   the Geometric Mean Longitude of the Sun in degrees
	'***********************************************************************/

Function calcGeomMeanLongSun(t)

	Dim l0

	l0 = 280.46646 + t * (36000.76983 + 0.0003032 * t)
	
	Do
		If (l0 <= 360) And (l0 >= 0) Then Exit Do
		If l0 > 360 Then l0 = l0 - 360
		If l0 < 0 Then l0 = l0 + 360
	Loop

	calcGeomMeanLongSun = l0

End Function



	'***********************************************************************/
	'* Name:    calGeomAnomalySun
	'* Type:    Function
	'* Purpose: calculate the Geometric Mean Anomaly of the Sun
	'* Arguments:
	'*   t : number of Julian centuries since J2000.0
	'* Return value:
	'*   the Geometric Mean Anomaly of the Sun in degrees
	'***********************************************************************/

Function calcGeomMeanAnomalySun(t)

	Dim m

	m = 357.52911 + t * (35999.05029 - 0.0001537 * t)
	calcGeomMeanAnomalySun = m

End Function



	'***********************************************************************/
	'* Name:    calcEccentricityEarthOrbit
	'* Type:    Function
	'* Purpose: calculate the eccentricity of earth's orbit
	'* Arguments:
	'*   t : number of Julian centuries since J2000.0
	'* Return value:
	'*   the unitless eccentricity
	'***********************************************************************/

Function calcEccentricityEarthOrbit(t)

	Dim e

	e = 0.016708634 - t * (0.000042037 + 0.0000001267 * t)
	calcEccentricityEarthOrbit = e

End Function



	'***********************************************************************/
	'* Name:    calcSunEqOfCenter
	'* Type:    Function
	'* Purpose: calculate the equation of center for the sun
	'* Arguments:
	'*   t : number of Julian centuries since J2000.0
	'* Return value:
	'*   in degrees
	'***********************************************************************/

Function calcSunEqOfCenter(t)

	Dim m, mrad, sinm, sin2m, sin3m
	Dim c

	m = calcGeomMeanAnomalySun(t)

	mrad = degToRad(m)
	sinm = Sin(mrad)
	sin2m = Sin(mrad + mrad)
	sin3m = Sin(mrad + mrad + mrad)

	c = sinm * (1.914602 - t * (0.004817 + 0.000014 * t)) _
	    + sin2m * (0.019993 - 0.000101 * t) + sin3m * 0.000289

	calcSunEqOfCenter = c

End Function



	'***********************************************************************/
	'* Name:    calcSunTrueLong
	'* Type:    Function
	'* Purpose: calculate the true longitude of the sun
	'* Arguments:
	'*   t : number of Julian centuries since J2000.0
	'* Return value:
	'*   sun's true longitude in degrees
	'***********************************************************************/

Function calcSunTrueLong(t)

	Dim l0, c, O

	l0 = calcGeomMeanLongSun(t)
	c = calcSunEqOfCenter(t)

	O = l0 + c
	calcSunTrueLong = O

End Function



	'***********************************************************************/
	'* Name:    calcSunTrueAnomaly (not used by sunrise, solarnoon, sunset)
	'* Type:    Function
	'* Purpose: calculate the true anamoly of the sun
	'* Arguments:
	'*   t : number of Julian centuries since J2000.0
	'* Return value:
	'*   sun's true anamoly in degrees
	'***********************************************************************/

Function calcSunTrueAnomaly(t)

	Dim m, c, v

	m = calcGeomMeanAnomalySun(t)
	c = calcSunEqOfCenter(t)

	v = m + c
	calcSunTrueAnomaly = v

End Function



	'***********************************************************************/
	'* Name:    calcSunRadVector (not used by sunrise, solarnoon, sunset)
	'* Type:    Function
	'* Purpose: calculate the distance to the sun in AU
	'* Arguments:
	'*   t : number of Julian centuries since J2000.0
	'* Return value:
	'*   sun radius vector in AUs
	'***********************************************************************/

Function calcSunRadVector(t)

	Dim v, e, R

	v = calcSunTrueAnomaly(t)
	e = calcEccentricityEarthOrbit(t)

	R = (1.000001018 * (1 - e * e)) / (1 + e * Cos(degToRad(v)))
	calcSunRadVector = R

End Function


	'***********************************************************************/
	'* Name:    calcSunApparentLong (not used by sunrise, solarnoon, sunset)
	'* Type:    Function
	'* Purpose: calculate the apparent longitude of the sun
	'* Arguments:
	'*   t : number of Julian centuries since J2000.0
	'* Return value:
	'*   sun's apparent longitude in degrees
	'***********************************************************************/

Function calcSunApparentLong(t)

	Dim O, omega, lambda

	O = calcSunTrueLong(t)

	omega = 125.04 - 1934.136 * t
	lambda = O - 0.00569 - 0.00478 * Sin(degToRad(omega))
	calcSunApparentLong = lambda

End Function



	'***********************************************************************/
	'* Name:    calcMeanObliquityOfEcliptic
	'* Type:    Function
	'* Purpose: calculate the mean obliquity of the ecliptic
	'* Arguments:
	'*   t : number of Julian centuries since J2000.0
	'* Return value:
	'*   mean obliquity in degrees
	'***********************************************************************/

Function calcMeanObliquityOfEcliptic(t)

	Dim seconds, e0

	seconds = 21.448 - t * (46.815 + t * (0.00059 - t * (0.001813)))
	e0 = 23 + (26 + (seconds / 60)) / 60
	calcMeanObliquityOfEcliptic = e0

End Function



	'***********************************************************************/
	'* Name:    calcObliquityCorrection
	'* Type:    Function
	'* Purpose: calculate the corrected obliquity of the ecliptic
	'* Arguments:
	'*   t : number of Julian centuries since J2000.0
	'* Return value:
	'*   corrected obliquity in degrees
	'***********************************************************************/

Function calcObliquityCorrection(t)

	Dim e0, omega, e

	e0 = calcMeanObliquityOfEcliptic(t)

	omega = 125.04 - 1934.136 * t
	e = e0 + 0.00256 * Cos(degToRad(omega))
	calcObliquityCorrection = e

End Function




	'***********************************************************************/
	'* Name:    calcSunRtAscension (not used by sunrise, solarnoon, sunset)
	'* Type:    Function
	'* Purpose: calculate the right ascension of the sun
	'* Arguments:
	'*   t : number of Julian centuries since J2000.0
	'* Return value:
	'*   sun's right ascension in degrees
	'***********************************************************************/

Function calcSunRtAscension(t)

	Dim e, lambda, tananum, tanadenom
	Dim alpha

	e = calcObliquityCorrection(t)
	lambda = calcSunApparentLong(t)

	tananum = (Cos(degToRad(e)) * Sin(degToRad(lambda)))
	tanadenom = (Cos(degToRad(lambda)))

		'original NOAA code using javascript Math.Atan2(y,x) convention:
		'        var alpha = radToDeg(Math.atan2(tananum, tanadenom));
		'        alpha = radToDeg(Application.WorksheetFunction.Atan2(tananum, tanadenom))

		'translated using Excel VBA Application.WorksheetFunction.Atan2(x,y) convention:
	alpha = radToDeg(Atan2(tanadenom, tananum))

	calcSunRtAscension = alpha

End Function



	'***********************************************************************/
	'* Name:    calcSunDeclination
	'* Type:    Function
	'* Purpose: calculate the declination of the sun
	'* Arguments:
	'*   t : number of Julian centuries since J2000.0
	'* Return value:
	'*   sun's declination in degrees
	'***********************************************************************/

Function calcSunDeclination(t)

	Dim e, lambda, sint, theta

	e = calcObliquityCorrection(t)
	lambda = calcSunApparentLong(t)

	sint = Sin(degToRad(e)) * Sin(degToRad(lambda))
	theta = radToDeg(Asin(sint))
	calcSunDeclination = theta

End Function



	'***********************************************************************/
	'* Name:    calcEquationOfTime
	'* Type:    Function
	'* Purpose: calculate the difference between true solar time and mean
	'*     solar time
	'* Arguments:
	'*   t : number of Julian centuries since J2000.0
	'* Return value:
	'*   equation of time in minutes of time
	'***********************************************************************/

Function calcEquationOfTime(t)

Dim epsilon, l0, e, m
Dim y, sin2l0, sinm
Dim cos2l0, sin4l0, sin2m, Etime

	epsilon = calcObliquityCorrection(t)
	l0 = calcGeomMeanLongSun(t)
	e = calcEccentricityEarthOrbit(t)
	m = calcGeomMeanAnomalySun(t)

	y = Tan(degToRad(epsilon) / 2)
	y = y ^ 2

	sin2l0 = Sin(2 * degToRad(l0))
	sinm = Sin(degToRad(m))
	cos2l0 = Cos(2 * degToRad(l0))
	sin4l0 = Sin(4 * degToRad(l0))
	sin2m = Sin(2 * degToRad(m))

	Etime = y * sin2l0 - 2 * e * sinm + 4 * e * y * sinm * cos2l0 _
	        - 0.5 * y * y * sin4l0 - 1.25 * e * e * sin2m

	calcEquationOfTime = radToDeg(Etime) * 4

End Function



	'***********************************************************************/
	'* Name:    calcHourAngleDawn
	'* Type:    Function
	'* Purpose: calculate the hour angle of the sun at dawn for the
	'*         latitude
	'*         for user selected solar depression below horizon
	'* Arguments:
	'*   lat : latitude of observer in degrees
	'*   solarDec : declination angle of sun in degrees
	'*   solardepression: angle of the sun below the horizion in degrees
	'* Return value:
	'*   hour angle of dawn in radians
	'***********************************************************************/

Function calcHourAngleDawn(lat, solarDec, solardepression)

	Dim latRad, sdRad, HAarg, HA

	latRad = degToRad(lat)
	sdRad = degToRad(solarDec)

	HAarg = (Cos(degToRad(90 + solardepression)) / (Cos(latRad) * Cos(sdRad)) - Tan(latRad) * Tan(sdRad))

	HA = (Acos(Cos(degToRad(90 + solardepression)) _
		  / (Cos(latRad) * Cos(sdRad)) - Tan(latRad) * Tan(sdRad)))

	calcHourAngleDawn = HA

End Function



	'***********************************************************************/
	'* Name:    calcHourAngleSunrise
	'* Type:    Function
	'* Purpose: calculate the hour angle of the sun at sunrise for the
	'*         latitude
	'* Arguments:
	'*   lat : latitude of observer in degrees
	'* solarDec : declination angle of sun in degrees
	'* Return value:
	'*   hour angle of sunrise in radians
	'*
	'* Note: For sunrise and sunset calculations, we assume 0.833° of atmospheric refraction
	'* For details about refraction see http://www.srrb.noaa.gov/highlights/sunrise/calcdetails.html
	'*
	'***********************************************************************/

Function calcHourAngleSunrise(lat, solarDec)

	Dim latRad, sdRad, HAarg, HA

	latRad = degToRad(lat)
	sdRad = degToRad(solarDec)

	HAarg = (Cos(degToRad(90.833)) / (Cos(latRad) * Cos(sdRad)) - Tan(latRad) * Tan(sdRad))

	HA = (Acos(Cos(degToRad(90.833)) _
		  / (Cos(latRad) * Cos(sdRad)) - Tan(latRad) * Tan(sdRad)))

	calcHourAngleSunrise = HA

End Function



	'***********************************************************************/
	'* Name:    calcHourAngleSunset
	'* Type:    Function
	'* Purpose: calculate the hour angle of the sun at sunset for the
	'*         latitude
	'* Arguments:
	'*   lat : latitude of observer in degrees
	'* solarDec : declination angle of sun in degrees
	'* Return value:
	'*   hour angle of sunset in radians
	'*
	'* Note: For sunrise and sunset calculations, we assume 0.833° of atmospheric refraction
	'* For details about refraction see http://www.srrb.noaa.gov/highlights/sunrise/calcdetails.html
	'*
	'***********************************************************************/

Function calcHourAngleSunset(lat, solarDec)

	Dim latRad, sdRad, HAarg, HA

	latRad = degToRad(lat)
	sdRad = degToRad(solarDec)

	HAarg = (Cos(degToRad(90.833)) / (Cos(latRad) * Cos(sdRad)) - Tan(latRad) * Tan(sdRad))

	HA = (Acos(Cos(degToRad(90.833)) _
		   / (Cos(latRad) * Cos(sdRad)) - Tan(latRad) * Tan(sdRad)))

	calcHourAngleSunset = -HA

End Function


	'***********************************************************************/
	'* Name:    calcHourAngleDusk
	'* Type:    Function
	'* Purpose: calculate the hour angle of the sun at dusk for the
	'*         latitude
	'*         for user selected solar depression below horizon
	'* Arguments:
	'*   lat : latitude of observer in degrees
	'*   solarDec : declination angle of sun in degrees
	'*   solardepression: angle of sun below horizon in degrees
	'* Return value:
	'*   hour angle of dusk in radians
	'***********************************************************************/

Function calcHourAngleDusk(lat, solarDec, solardepression)

	Dim latRad, sdRad, HAarg, HA

	latRad = degToRad(lat)
	sdRad = degToRad(solarDec)

	HAarg = (Cos(degToRad(90 + solardepression)) / (Cos(latRad) * Cos(sdRad)) - Tan(latRad) * Tan(sdRad))

	HA = (Acos(Cos(degToRad(90 + solardepression)) _
	     / (Cos(latRad) * Cos(sdRad)) - Tan(latRad) * Tan(sdRad)))

	calcHourAngleDusk = -HA

End Function




	'***********************************************************************/
	'* Name:    calcDawnUTC
	'* Type:    Function
	'* Purpose: calculate the Universal Coordinated Time (UTC) of dawn
	'*         for the given day at the given location on earth
	'*         for user selected solar depression below horizon
	'* Arguments:
	'*   JD  : julian day
	'*   latitude : latitude of observer in degrees
	'*   longitude : longitude of observer in degrees
	'*   solardepression: angle of sun below the horizon in degrees
	'* Return value:
	'*   time in minutes from zero Z
	'***********************************************************************/

Function calcDawnUTC(JD, latitude, longitude, solardepression)

	Dim t, eqtime, solarDec, hourangle
	Dim delta, timeDiff, timeUTC
	Dim newt

	t = calcTimeJulianCent(JD)

		'        // *** First pass to approximate sunrise

	eqtime = calcEquationOfTime(t)
	solarDec = calcSunDeclination(t)
	hourangle = calcHourAngleSunrise(latitude, solarDec)

	delta = longitude - radToDeg(hourangle)
	timeDiff = 4 * delta
		' in minutes of time
	timeUTC = 720 + timeDiff - eqtime
		' in minutes

		' *** Second pass includes fractional jday in gamma calc

	newt = calcTimeJulianCent(calcJDFromJulianCent(t) + timeUTC / 1440)
	eqtime = calcEquationOfTime(newt)
	solarDec = calcSunDeclination(newt)
	hourangle = calcHourAngleDawn(latitude, solarDec, solardepression)
	delta = longitude - radToDeg(hourangle)
	timeDiff = 4 * delta
	timeUTC = 720 + timeDiff - eqtime
		' in minutes

	calcDawnUTC = timeUTC

End Function


	'***********************************************************************/
	'* Name:    calcSunriseUTC
	'* Type:    Function
	'* Purpose: calculate the Universal Coordinated Time (UTC) of sunrise
	'*         for the given day at the given location on earth
	'* Arguments:
	'*   JD  : julian day
	'*   latitude : latitude of observer in degrees
	'*   longitude : longitude of observer in degrees
	'* Return value:
	'*   time in minutes from zero Z
	'***********************************************************************/

Function calcSunriseUTC(JD, latitude, longitude)

	Dim t, eqtime, solarDec, hourangle
	Dim delta, timeDiff, timeUTC
	Dim newt

	t = calcTimeJulianCent(JD)

		'        // *** First pass to approximate sunrise

	eqtime = calcEquationOfTime(t)
	solarDec = calcSunDeclination(t)
	hourangle = calcHourAngleSunrise(latitude, solarDec)

	delta = longitude - radToDeg(hourangle)
	timeDiff = 4 * delta
		' in minutes of time
	timeUTC = 720 + timeDiff - eqtime
		' in minutes

		' *** Second pass includes fractional jday in gamma calc

	newt = calcTimeJulianCent(calcJDFromJulianCent(t) + timeUTC / 1440)
	eqtime = calcEquationOfTime(newt)
	solarDec = calcSunDeclination(newt)
	hourangle = calcHourAngleSunrise(latitude, solarDec)
	delta = longitude - radToDeg(hourangle)
	timeDiff = 4 * delta
	timeUTC = 720 + timeDiff - eqtime
		' in minutes

	calcSunriseUTC = timeUTC

End Function




	'***********************************************************************/
	'* Name:    calcSolNoonUTC
	'* Type:    Function
	'* Purpose: calculate the Universal Coordinated Time (UTC) of solar
	'*     noon for the given day at the given location on earth
	'* Arguments:
	'*   t : number of Julian centuries since J2000.0
	'*   longitude : longitude of observer in degrees
	'* Return value:
	'*   time in minutes from zero Z
	'***********************************************************************/

Function calcSolNoonUTC(t, longitude)

	Dim newt, eqtime, solarNoonDec, solNoonUTC

	newt = calcTimeJulianCent(calcJDFromJulianCent(t) + 0.5 + longitude / 360)

	eqtime = calcEquationOfTime(newt)
	solarNoonDec = calcSunDeclination(newt)
	solNoonUTC = 720 + (longitude * 4) - eqtime

	calcSolNoonUTC = solNoonUTC

End Function


	'***********************************************************************/
	'* Name:    calcSunsetUTC
	'* Type:    Function
	'* Purpose: calculate the Universal Coordinated Time (UTC) of sunset
	'*         for the given day at the given location on earth
	'* Arguments:
	'*   JD  : julian day
	'*   latitude : latitude of observer in degrees
	'*   longitude : longitude of observer in degrees
	'* Return value:
	'*   time in minutes from zero Z
	'***********************************************************************/

Function calcSunsetUTC(JD, latitude, longitude)

	Dim t, eqtime, solarDec, hourangle
	Dim delta, timeDiff, timeUTC
	Dim newt

	t = calcTimeJulianCent(JD)

		'        // First calculates sunrise and approx length of day

	eqtime = calcEquationOfTime(t)
	solarDec = calcSunDeclination(t)
	hourangle = calcHourAngleSunset(latitude, solarDec)

	delta = longitude - radToDeg(hourangle)
	timeDiff = 4 * delta
	timeUTC = 720 + timeDiff - eqtime

		'        // first pass used to include fractional day in gamma calc

	newt = calcTimeJulianCent(calcJDFromJulianCent(t) + timeUTC / 1440)
	eqtime = calcEquationOfTime(newt)
	solarDec = calcSunDeclination(newt)
	hourangle = calcHourAngleSunset(latitude, solarDec)

	delta = longitude - radToDeg(hourangle)
	timeDiff = 4 * delta
	timeUTC = 720 + timeDiff - eqtime
		'        // in minutes

	calcSunsetUTC = timeUTC

End Function


	'***********************************************************************/
	'* Name:    calcDuskUTC
	'* Type:    Function
	'* Purpose: calculate the Universal Coordinated Time (UTC) of dusk
	'*         for the given day at the given location on earth
	'*         for user selected solar depression below horizon
	'* Arguments:
	'*   JD  : julian day
	'*   latitude : latitude of observer in degrees
	'*   longitude : longitude of observer in degrees
	'*   solardepression: angle of sun below horizon
	'* Return value:
	'*   time in minutes from zero Z
	'***********************************************************************/

Function calcDuskUTC(JD, latitude, longitude, solardepression)

	Dim t, eqtime, solarDec, hourangle
	Dim delta, timeDiff, timeUTC
	Dim newt

	t = calcTimeJulianCent(JD)

	'        // First calculates sunrise and approx length of day

	eqtime = calcEquationOfTime(t)
	solarDec = calcSunDeclination(t)
	hourangle = calcHourAngleSunset(latitude, solarDec)

	delta = longitude - radToDeg(hourangle)
	timeDiff = 4 * delta
	timeUTC = 720 + timeDiff - eqtime

		'        // first pass used to include fractional day in gamma calc

	newt = calcTimeJulianCent(calcJDFromJulianCent(t) + timeUTC / 1440)
	eqtime = calcEquationOfTime(newt)
	solarDec = calcSunDeclination(newt)
	hourangle = calcHourAngleDusk(latitude, solarDec, solardepression)

	delta = longitude - radToDeg(hourangle)
	timeDiff = 4 * delta
	timeUTC = 720 + timeDiff - eqtime
		'        // in minutes

	calcDuskUTC = timeUTC

End Function


	'***********************************************************************/
	'* Name:    dawn
	'* Type:    Main Function called by spreadsheet
	'* Purpose: calculate time of dawn  for the entered date
	'*     and location.
	'* For latitudes greater than 72 degrees N and S, calculations are
	'* accurate to within 10 minutes. For latitudes less than +/- 72°
	'* accuracy is approximately one minute.
	'* Arguments:
	'   latitude = latitude (decimal degrees)
	'   longitude = longitude (decimal degrees)
	'    NOTE: longitude is negative for western hemisphere for input cells
	'          in the spreadsheet for calls to the functions named
	'          sunrise, solarnoon, and sunset. Those functions convert the
	'          longitude to positive for the western hemisphere for calls to
	'          other functions using the original sign convention
	'          from the NOAA javascript code.
	'   year = year
	'   month = month
	'   day = day
	'   timezone = time zone hours relative to GMT/UTC (hours)
	'   dlstime = daylight savings time (0 = no, 1 = yes) (hours)
	'   solardepression = angle of sun below horizon in degrees
	'* Return value:
	'*   dawn time in local time (days)
	'***********************************************************************/

Function dawn(lat, lon, yearin, monthin, dayin, timezone, dlstime, solardepression)

	Dim longitude, latitude, JD
	Dim riseTimeGMT, riseTimeLST

		' change sign convention for longitude from negative to positive in western hemisphere
	longitude = lon * -1
	latitude = lat
	If (latitude > 89.8) Then latitude = 89.8
	If (latitude < -89.8) Then latitude = -89.8

	JD = calcJD(yearin, monthin, dayin)

		'            // Calculate sunrise for this date
	riseTimeGMT = calcDawnUTC(JD, latitude, longitude, solardepression)

		'            //  adjust for time zone and daylight savings time in minutes
	riseTimeLST = riseTimeGMT + (60 * timezone) + (dlstime * 60)

		'            //  convert to days
	dawn = riseTimeLST / 1440

End Function


	'***********************************************************************/
	'* Name:    sunrise
	'* Type:    Main Function called by spreadsheet
	'* Purpose: calculate time of sunrise  for the entered date
	'*     and location.
	'* For latitudes greater than 72 degrees N and S, calculations are
	'* accurate to within 10 minutes. For latitudes less than +/- 72°
	'* accuracy is approximately one minute.
	'* Arguments:
	'   latitude = latitude (decimal degrees)
	'   longitude = longitude (decimal degrees)
	'    NOTE: longitude is negative for western hemisphere for input cells
	'          in the spreadsheet for calls to the functions named
	'          sunrise, solarnoon, and sunset. Those functions convert the
	'          longitude to positive for the western hemisphere for calls to
	'          other functions using the original sign convention
	'          from the NOAA javascript code.
	'   year = year
	'   month = month
	'   day = day
	'   timezone = time zone hours relative to GMT/UTC (hours)
	'   dlstime = daylight savings time (0 = no, 1 = yes) (hours)
	'* Return value:
	'*   sunrise time in local time (days)
	'***********************************************************************/

Function sunrise(lat, lon, yearin, monthin, dayin, timezone, dlstime)

	Dim longitude, latitude, JD
	Dim riseTimeGMT, riseTimeLST

		' change sign convention for longitude from negative to positive in western hemisphere
	longitude = lon * -1
	latitude = lat
	If (latitude > 89.8) Then latitude = 89.8
	If (latitude < -89.8) Then latitude = -89.8

	JD = calcJD(yearin, monthin, dayin)

		'            // Calculate sunrise for this date
	riseTimeGMT = calcSunriseUTC(JD, latitude, longitude)

		'            //  adjust for time zone and daylight savings time in minutes
	riseTimeLST = riseTimeGMT + (60 * timezone) + (dlstime * 60)

		'            //  convert to days
	sunrise = riseTimeLST / 1440

End Function


	'***********************************************************************/
	'* Name:    solarnoon
	'* Type:    Main Function called by spreadsheet
	'* Purpose: calculate the Universal Coordinated Time (UTC) of solar
	'*     noon for the given day at the given location on earth
	'* Arguments:
	'    year
	'    month
	'    day
	'*   longitude : longitude of observer in degrees
	'    NOTE: longitude is negative for western hemisphere for input cells
	'          in the spreadsheet for calls to the functions named
	'          sunrise, solarnoon, and sunset. Those functions convert the
	'          longitude to positive for the western hemisphere for calls to
	'          other functions using the original sign convention
	'          from the NOAA javascript code.
	'* Return value:
	'*   time of solar noon in local time days
	'***********************************************************************/

Function solarnoon(lat, lon, yearin, monthin, dayin, timezone, dlstime)

	Dim longitude, latitude, JD
	Dim t, newt, eqtime
	Dim solarNoonDec, solNoonUTC
                
		' change sign convention for longitude from negative to positive in western hemisphere
	longitude = lon * -1
	latitude = lat
	If (latitude > 89.8) Then latitude = 89.8
	If (latitude < -89.8) Then latitude = -89.8

	JD = calcJD(yearin, monthin, dayin)
	t = calcTimeJulianCent(JD)

	newt = calcTimeJulianCent(calcJDFromJulianCent(t) + 0.5 + longitude / 360)

	eqtime = calcEquationOfTime(newt)
	solarNoonDec = calcSunDeclination(newt)
	solNoonUTC = 720 + (longitude * 4) - eqtime

		'            //  adjust for time zone and daylight savings time in minutes
	solarnoon = solNoonUTC + (60 * timezone) + (dlstime * 60)

		'            //  convert to days
	solarnoon = solarnoon / 1440

End Function



	'***********************************************************************/
	'* Name:    sunset
	'* Type:    Main Function called by spreadsheet
	'* Purpose: calculate time of sunrise and sunset for the entered date
	'*     and location.
	'* For latitudes greater than 72 degrees N and S, calculations are
	'* accurate to within 10 minutes. For latitudes less than +/- 72°
	'* accuracy is approximately one minute.
	'* Arguments:
	'   latitude = latitude (decimal degrees)
	'   longitude = longitude (decimal degrees)
	'    NOTE: longitude is negative for western hemisphere for input cells
	'          in the spreadsheet for calls to the functions named
	'          sunrise, solarnoon, and sunset. Those functions convert the
	'          longitude to positive for the western hemisphere for calls to
	'          other functions using the original sign convention
	'          from the NOAA javascript code.
	'   year = year
	'   month = month
	'   day = day
	'   timezone = time zone hours relative to GMT/UTC (hours)
	'   dlstime = daylight savings time (0 = no, 1 = yes) (hours)
	'* Return value:
	'*   sunset time in local time (days)
	'***********************************************************************/

Function sunset(lat, lon, yearin, monthin, dayin, timezone, dlstime)

	Dim longitude, latitude, JD
	Dim setTimeGMT, setTimeLST

' change sign convention for longitude from negative to positive in western hemisphere
	longitude = lon * -1
	latitude = lat
	If (latitude > 89.8) Then latitude = 89.8
	If (latitude < -89.8) Then latitude = -89.8

	JD = calcJD(yearin, monthin, dayin)

'           // Calculate sunset for this date
	setTimeGMT = calcSunsetUTC(JD, latitude, longitude)

'            //  adjust for time zone and daylight savings time in minutes
	setTimeLST = setTimeGMT + (60 * timezone) + (dlstime * 60)

'            //  convert to days
	sunset = setTimeLST / 1440

End Function


	'***********************************************************************/
	'* Name:    dusk
	'* Type:    Main Function called by spreadsheet
	'* Purpose: calculate time of sunrise and sunset for the entered date
	'*     and location.
	'* For latitudes greater than 72 degrees N and S, calculations are
	'* accurate to within 10 minutes. For latitudes less than +/- 72°
	'* accuracy is approximately one minute.
	'* Arguments:
	'   latitude = latitude (decimal degrees)
	'   longitude = longitude (decimal degrees)
	'    NOTE: longitude is negative for western hemisphere for input cells
	'          in the spreadsheet for calls to the functions named
	'          sunrise, solarnoon, and sunset. Those functions convert the
	'          longitude to positive for the western hemisphere for calls to
	'          other functions using the original sign convention
	'          from the NOAA javascript code.
	'   year = year
	'   month = month
	'   day = day
	'   timezone = time zone hours relative to GMT/UTC (hours)
	'   dlstime = daylight savings time (0 = no, 1 = yes) (hours)
	'   solardepression = angle of sun below horizon in degrees
	'* Return value:
	'*   dusk time in local time (days)
	'***********************************************************************/

Function dusk(lat, lon, yearin, monthin, dayin, timezone, dlstime, solardepression)

	Dim longitude, latitude, JD
	Dim setTimeGMT, setTimeLST

		' change sign convention for longitude from negative to positive in western hemisphere
	longitude = lon * -1
	latitude = lat
	If (latitude > 89.8) Then latitude = 89.8
	If (latitude < -89.8) Then latitude = -89.8

	JD = calcJD(yearin, monthin, dayin)

	'           // Calculate sunset for this date
	setTimeGMT = calcDuskUTC(JD, latitude, longitude, solardepression)

	'            //  adjust for time zone and daylight savings time in minutes
	setTimeLST = setTimeGMT + (60 * timezone) + (dlstime * 60)

	'            //  convert to days
	dusk = setTimeLST / 1440

End Function


	'***********************************************************************/
	'* Name:    solarazimuth
	'* Type:    Main Function
	'* Purpose: calculate solar azimuth (deg from north) for the entered
	'*          date, time and location. Returns -999999 if darker than twilight
	'*
	'* Arguments:
	'*   latitude, longitude, year, month, day, hour, minute, second,
	'*   timezone, daylightsavingstime
	'* Return value:
	'*   solar azimuth in degrees from north
	'*
	'* Note: solarelevation and solarazimuth functions are identical
	'*       and could be converted to a VBA subroutine that would return
	'*       both values.
	'*
	'***********************************************************************/

Function solarazimuth(lat, lon, yearin, monthin, dayin, _
                      hours, minutes, seconds, timezone, dlstime)

	Dim longitude, latitude
	Dim zone, daySavings
	Dim hh, mm, ss, timenow
	Dim JD, t, R
	Dim alpha, theta, Etime, eqtime
	Dim solarDec, earthRadVec, solarTimeFix
	Dim trueSolarTime, hourangle, harad
	Dim csz, zenith, azDenom, azRad
	Dim azimuth, exoatmElevation
	Dim step1, step2, step3
	Dim refractionCorrection, te, solarzen

		' change sign convention for longitude from negative to positive in western hemisphere
	longitude = lon * -1
	latitude = lat
	If (latitude > 89.8) Then latitude = 89.8
	If (latitude < -89.8) Then latitude = -89.8

		'change time zone to ppositive hours in western hemisphere
	zone = timezone * -1
	daySavings = dlstime * 60
	hh = hours - (daySavings / 60)
	mm = minutes
	ss = seconds

		'//    timenow is GMT time for calculation in hours since 0Z
	timenow = hh + mm / 60 + ss / 3600 + zone

	JD = calcJD(yearin, monthin, dayin)
	t = calcTimeJulianCent(JD + timenow / 24)
	R = calcSunRadVector(t)
	alpha = calcSunRtAscension(t)
	theta = calcSunDeclination(t)
	Etime = calcEquationOfTime(t)

	eqtime = Etime
	solarDec = theta '//    in degrees
	earthRadVec = R

	solarTimeFix = eqtime - 4 * longitude + 60 * zone
	trueSolarTime = hh * 60 + mm + ss / 60 + solarTimeFix
	'//    in minutes

	Do While (trueSolarTime > 1440)
		trueSolarTime = trueSolarTime - 1440
	Loop

	hourangle = trueSolarTime / 4 - 180
	'//    Thanks to Louis Schwarzmayr for the next line:
	If (hourangle < -180) Then hourangle = hourangle + 360

	harad = degToRad(hourangle)

	csz = Sin(degToRad(latitude)) * _
		Sin(degToRad(solarDec)) + _
		Cos(degToRad(latitude)) * _
		Cos(degToRad(solarDec)) * Cos(harad)

	If (csz > 1) Then
		csz = 1
	ElseIf (csz < -1) Then
		csz = -1
	End If

	zenith = radToDeg(Acos(csz))

	azDenom = (Cos(degToRad(latitude)) * Sin(degToRad(zenith)))

	If (Abs(azDenom) > 0.001) Then
		azRad = ((Sin(degToRad(latitude)) * _
			Cos(degToRad(zenith))) - _
			Sin(degToRad(solarDec))) / azDenom

		If (Abs(azRad) > 1) Then
			If (azRad < 0) Then
				azRad = -1
			Else
				azRad = 1
			End If
		End If

		azimuth = 180 - radToDeg(Acos(azRad))

		If (hourangle > 0) Then
			azimuth = -azimuth
		End If
		
	Else
		If (latitude > 0) Then
			azimuth = 180
		Else
			azimuth = 0
		End If
	End If
	
	If (azimuth < 0) Then
		azimuth = azimuth + 360
	End If

	exoatmElevation = 90 - zenith

'beginning of complex expression commented out
'            If (exoatmElevation > 85) Then
'                refractionCorrection = 0
'            Else
'                te = Tan(degToRad(exoatmElevation))
'                If (exoatmElevation > 5) Then
'                    refractionCorrection = 58.1 / te - 0.07 / (te * te * te) + _
'                        0.000086 / (te * te * te * te * te)
'                ElseIf (exoatmElevation > -0.575) Then
'                    refractionCorrection = 1735 + exoatmElevation * _
'                        (-518.2 + exoatmElevation * (103.4 + _
'                        exoatmElevation * (-12.79 + _
'                        exoatmElevation * 0.711)))
'                Else
'                    refractionCorrection = -20.774 / te
'                End If
'                refractionCorrection = refractionCorrection / 3600
'            End If
'end of complex expression

	'beginning of simplified expression
	If (exoatmElevation > 85) Then
		refractionCorrection = 0
	Else
		te = Tan(degToRad(exoatmElevation))
		
		If (exoatmElevation > 5) Then
			refractionCorrection = 58.1 / te - 0.07 / (te * te * te) + _
				0.000086 / (te * te * te * te * te)
				
		ElseIf (exoatmElevation > -0.575) Then
			step1 = (-12.79 + exoatmElevation * 0.711)
			step2 = (103.4 + exoatmElevation * (step1))
			step3 = (-518.2 + exoatmElevation * (step2))
			refractionCorrection = 1735 + exoatmElevation * (step3)
			
		Else
			refractionCorrection = -20.774 / te
		End If
		
		refractionCorrection = refractionCorrection / 3600
	End If
'end of simplified expression

	solarzen = zenith - refractionCorrection
	solarazimuth = azimuth

	'            If (solarZen < 108) Then
	'solarazimuth = azimuth
	'              solarelevation = 90 - solarZen
	'              If (solarZen < 90) Then
	'                coszen = Cos(degToRad(solarZen))
	'              Else
	'                coszen = 0
	'              End If
	'            Else    '// do not report az & el after astro twilight
	'              solarazimuth = -999999
	'              solarelevation = -999999
	'              coszen = -999999
	'            End If

End Function


	'***********************************************************************/
	'* Name:    solarazimuth
	'* Type:    Main Function
	'* Purpose: calculate solar azimuth (deg from north) for the entered
	'*          date, time and location. Returns -999999 if darker than twilight
	'*
	'* Arguments:
	'*   latitude, longitude, year, month, day, hour, minute, second,
	'*   timezone, daylightsavingstime
	'* Return value:
	'*   solar azimuth in degrees from north
	'*
	'* Note: solarelevation and solarazimuth functions are identical
	'*       and could converted to a VBA subroutine that would return
	'*       both values.
	'*
	'***********************************************************************/

Function solarelevation(lat, lon, yearin, monthin, dayin, _
                      hours, minutes, seconds, timezone, dlstime)

	Dim longitude, latitude
	Dim zone, daySavings
	Dim hh, mm, ss, timenow
	Dim JD, t, R
	Dim alpha, theta, Etime, eqtime
	Dim solarDec, earthRadVec, solarTimeFix
	Dim trueSolarTime, hourangle, harad
	Dim csz, zenith, azDenom, azRad
	Dim azimuth, exoatmElevation
	Dim step1, step2, step3
	Dim refractionCorrection, te, solarzen

		' change sign convention for longitude from negative to positive in western hemisphere
	longitude = lon * -1
	latitude = lat
	If (latitude > 89.8) Then latitude = 89.8
	If (latitude < -89.8) Then latitude = -89.8

		'change time zone to ppositive hours in western hemisphere
	zone = timezone * -1
	daySavings = dlstime * 60
	hh = hours - (daySavings / 60)
	mm = minutes
	ss = seconds

	'//    timenow is GMT time for calculation in hours since 0Z
	timenow = hh + mm / 60 + ss / 3600 + zone

	JD = calcJD(yearin, monthin, dayin)
	t = calcTimeJulianCent(JD + timenow / 24)
	R = calcSunRadVector(t)
	alpha = calcSunRtAscension(t)
	theta = calcSunDeclination(t)
	Etime = calcEquationOfTime(t)

	eqtime = Etime
	solarDec = theta '//    in degrees
	earthRadVec = R

	solarTimeFix = eqtime - 4 * longitude + 60 * zone
	trueSolarTime = hh * 60 + mm + ss / 60 + solarTimeFix
	'//    in minutes

	Do While (trueSolarTime > 1440)
		trueSolarTime = trueSolarTime - 1440
	Loop
            
	hourangle = trueSolarTime / 4 - 180
	'//    Thanks to Louis Schwarzmayr for the next line:
	If (hourangle < -180) Then hourangle = hourangle + 360

	harad = degToRad(hourangle)

	csz = Sin(degToRad(latitude)) * _
	Sin(degToRad(solarDec)) + _
	Cos(degToRad(latitude)) * _
	Cos(degToRad(solarDec)) * Cos(harad)

	If (csz > 1) Then
		csz = 1
	ElseIf (csz < -1) Then
		csz = -1
	End If

	zenith = radToDeg(Acos(csz))

	azDenom = (Cos(degToRad(latitude)) * Sin(degToRad(zenith)))

	If (Abs(azDenom) > 0.001) Then
		azRad = ((Sin(degToRad(latitude)) * _
		Cos(degToRad(zenith))) - _
		Sin(degToRad(solarDec))) / azDenom
		
		If (Abs(azRad) > 1) Then
			If (azRad < 0) Then
				azRad = -1
			Else
				azRad = 1
			End If
		End If

		azimuth = 180 - radToDeg(Acos(azRad))

		If (hourangle > 0) Then
			azimuth = -azimuth
		End If
	
	Else
	
		If (latitude > 0) Then
			azimuth = 180
		Else
			azimuth = 0
		End If
	End If
	
	If (azimuth < 0) Then
		azimuth = azimuth + 360
	End If

	exoatmElevation = 90 - zenith

'beginning of complex expression commented out
'            If (exoatmElevation > 85) Then
'                refractionCorrection = 0
'            Else
'                te = Tan(degToRad(exoatmElevation))
'                If (exoatmElevation > 5) Then
'                    refractionCorrection = 58.1 / te - 0.07 / (te * te * te) + _
'                        0.000086 / (te * te * te * te * te)
'                ElseIf (exoatmElevation > -0.575) Then
'                    refractionCorrection = 1735 + exoatmElevation * _
'                        (-518.2 + exoatmElevation * (103.4 + _
'                        exoatmElevation * (-12.79 + _
'                        exoatmElevation * 0.711)))
'                Else
'                    refractionCorrection = -20.774 / te
'                End If
'                refractionCorrection = refractionCorrection / 3600
'            End If
'end of complex expression

'beginning of simplified expression
	If (exoatmElevation > 85) Then
		refractionCorrection = 0
	Else
		te = Tan(degToRad(exoatmElevation))
		
		If (exoatmElevation > 5) Then
			refractionCorrection = 58.1 / te - 0.07 / (te * te * te) + _
				0.000086 / (te * te * te * te * te)
		ElseIf (exoatmElevation > -0.575) Then
			step1 = (-12.79 + exoatmElevation * 0.711)
			step2 = (103.4 + exoatmElevation * (step1))
			step3 = (-518.2 + exoatmElevation * (step2))
			refractionCorrection = 1735 + exoatmElevation * (step3)
		Else
			refractionCorrection = -20.774 / te
		End If
		
		refractionCorrection = refractionCorrection / 3600
	End If
'end of simplified expression

	solarzen = zenith - refractionCorrection
	solarelevation = 90 - solarzen

'            If (solarZen < 108) Then
'              solarazimuth = azimuth
'	solarelevation = 90 - solarzen
'              If (solarZen < 90) Then
'                coszen = Cos(degToRad(solarZen))
'              Else
'                coszen = 0
'              End If
'            Else    '// do not report az & el after astro twilight
'              solarazimuth = -999999
'              solarelevation = -999999
'              coszen = -999999
'            End If

End Function




'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''    START OF SUBROUTINES                                    '''''
''''                                                            '''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''


	'***********************************************************************/
	'* Name:    solarazimuth
	'* Type:    Main Function
	'* Purpose: calculate solar azimuth (deg from north) for the entered
	'*          date, time and location. Returns -999999 if darker than twilight
	'*
	'* Arguments:
	'*   latitude, longitude, year, month, day, hour, minute, second,
	'*   timezone, daylightsavingstime
	'* Return value:
	'*   solar azimuth in degrees from north
	'*
	'* Note: solarelevation and solarazimuth functions are identical
	'*       and could converted to a VBA subroutine that would return
	'*       both values.
	'*
	'***********************************************************************/

Sub solarposition(lat, lon, yearin, monthin, dayin, _
        hours, minutes, seconds, timezone, dlstime, solarazimuth, solarelevation)

	Dim longitude, latitude
	Dim zone, daySavings
	Dim hh, mm, ss, timenow
	Dim JD, t, R
	Dim alpha, theta, Etime, eqtime
	Dim solarDec, earthRadVec, solarTimeFix
	Dim trueSolarTime, hourangle, harad
	Dim csz, zenith, azDenom, azRad
	Dim azimuth, exoatmElevation
	Dim step1, step2, step3
	Dim refractionCorrection, te, solarzen

		' change sign convention for longitude from negative to positive in western hemisphere
	longitude = lon * -1
	latitude = lat
	If (latitude > 89.8) Then latitude = 89.8
	If (latitude < -89.8) Then latitude = -89.8

		'change time zone to ppositive hours in western hemisphere
	zone = timezone * -1
	daySavings = dlstime * 60
	hh = hours - (daySavings / 60)
	mm = minutes
	ss = seconds

		'//    timenow is GMT time for calculation in hours since 0Z
	timenow = hh + mm / 60 + ss / 3600 + zone

	JD = calcJD(yearin, monthin, dayin)
	t = calcTimeJulianCent(JD + timenow / 24)
	R = calcSunRadVector(t)
	alpha = calcSunRtAscension(t)
	theta = calcSunDeclination(t)
	Etime = calcEquationOfTime(t)

	eqtime = Etime
	solarDec = theta '//    in degrees
	earthRadVec = R

	solarTimeFix = eqtime - 4 * longitude + 60 * zone
	trueSolarTime = hh * 60 + mm + ss / 60 + solarTimeFix
	'//    in minutes

	Do While (trueSolarTime > 1440)
		trueSolarTime = trueSolarTime - 1440
	Loop

	hourangle = trueSolarTime / 4 - 180
		'//    Thanks to Louis Schwarzmayr for the next line:
	If (hourangle < -180) Then hourangle = hourangle + 360

	harad = degToRad(hourangle)

	csz = Sin(degToRad(latitude)) * _
	Sin(degToRad(solarDec)) + _
	Cos(degToRad(latitude)) * _
	Cos(degToRad(solarDec)) * Cos(harad)

	If (csz > 1) Then
		csz = 1
	ElseIf (csz < -1) Then
		csz = -1
	End If

	zenith = radToDeg(Acos(csz))

	azDenom = (Cos(degToRad(latitude)) * Sin(degToRad(zenith)))

	If (Abs(azDenom) > 0.001) Then
		azRad = ((Sin(degToRad(latitude)) * _
		Cos(degToRad(zenith))) - _
		Sin(degToRad(solarDec))) / azDenom
		
		If (Abs(azRad) > 1) Then
			If (azRad < 0) Then
				azRad = -1
			Else
				azRad = 1
			End If
		End If

		azimuth = 180 - radToDeg(Acos(azRad))

		If (hourangle > 0) Then
			azimuth = -azimuth
		End If
	Else
		If (latitude > 0) Then
			azimuth = 180
		Else
			azimuth = 0
		End If
	End If

	If (azimuth < 0) Then
		azimuth = azimuth + 360
	End If

	exoatmElevation = 90 - zenith

'beginning of complex expression commented out
'            If (exoatmElevation > 85) Then
'                refractionCorrection = 0
'            Else
'                te = Tan(degToRad(exoatmElevation))
'                If (exoatmElevation > 5) Then
'                    refractionCorrection = 58.1 / te - 0.07 / (te * te * te) + _
'                        0.000086 / (te * te * te * te * te)
'                ElseIf (exoatmElevation > -0.575) Then
'                    refractionCorrection = 1735 + exoatmElevation * _
'                        (-518.2 + exoatmElevation * (103.4 + _
'                        exoatmElevation * (-12.79 + _
'                        exoatmElevation * 0.711)))
'                Else
'                    refractionCorrection = -20.774 / te
'                End If
'                refractionCorrection = refractionCorrection / 3600
'            End If
'end of complex expression


		'beginning of simplified expression
	If (exoatmElevation > 85) Then
		refractionCorrection = 0
	Else
		te = Tan(degToRad(exoatmElevation))

		If (exoatmElevation > 5) Then
			refractionCorrection = 58.1 / te - 0.07 / (te * te * te) + _
				0.000086 / (te * te * te * te * te)
		ElseIf (exoatmElevation > -0.575) Then
			step1 = (-12.79 + exoatmElevation * 0.711)
			step2 = (103.4 + exoatmElevation * (step1))
			step3 = (-518.2 + exoatmElevation * (step2))
			refractionCorrection = 1735 + exoatmElevation * (step3)
		Else
			refractionCorrection = -20.774 / te
		End If

		refractionCorrection = refractionCorrection / 3600
	End If

	'end of simplified expression


	solarzen = zenith - refractionCorrection

	'            If (solarZen < 108) Then
	solarazimuth = azimuth
	solarelevation = 90 - solarzene 
	'              If (solarZen < 90) Then
	'                coszen = Cos(degToRad(solarZen))
	'              Else
	'                coszen = 0
	'              End If
	'            Else    '// do not report az & el after astro twilight
	'              solarazimuth = -999999
	'              solarelevation = -999999
	'              coszen = -999999
	'            End If

End Sub

