
:MAIN

set bat_returncode=99
call :%~1

:DONE
exit /b !bat_returncode!


        rem 17. Upload Zip via FTP ************************************
:UPLOADFTP
!bat_pushlog! [CALL !bat_batchfile!:UPLOADFTP] %*
        set bat_retval=failed
        
        if defined bat_FTPUPLOAD.alternate_FTPUPLOAD (
                !bat_log! call "!bat_exedir!\!bat_FTPUPLOAD.alternate_FTPUPLOAD!"
                          call "!bat_exedir!\!bat_FTPUPLOAD.alternate_FTPUPLOAD!"
                goto :UPLOADFTP_END
        )

        if /i "!bat_submissionfilesdir!" equ "" (
                !bat_echolog!
                !bat_echolog!     Run Submission before zipping: 
                goto :UPLOADFTP_END
        )

                rem This is a one-time prompt. The password will be recorded into AutoCams.bat.ini
                rem and the question won't be asked again.
        if /i "!bat_ftppassword!" equ "" (
                !bat_echolog!
                !bat_echolog!
                set bat_choice=
                          !bat_prompt! Enter your email address as the anonymous FTP password: 
                !bat_log! set /P bat_choice=.!bat_pushstring!Enter your email address as the anonymous FTP password: !bat_choice!
                set bat_ftppassword=!bat_choice!
                !bat_log! set bat_ftppassword=!bat_ftppassword!
                call :SAVECONFIG
        )

        !bat_echolog! set bat_ftpfile=!bat_exedir!\ftp.temp.txt
                      set bat_ftpfile=!bat_exedir!\ftp.temp.txt

                rem Handle the case where an existing FTP with the same name has already been
                rem uploaded.  Since the users won't typically have delete rights, they will
                rem need to load a different file.  So, we need to list all the existing 
                rem zip files (in ascending date order), add a sequence number to the file name,
                rem and upload the newly sequenced file.  Of course, there is the likelihood that
                rem no file exists.
        set bat_zipfile=
        set bat_zip=
        !bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip" /a-d /b /od`^) do ...
        for               /f "usebackq tokens=*" %%a in  (`dir "!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip" /a-d /b /od`) do (
                set bat_zipfile=!bat_targetlocation!\CAMS\Submitted\%%~a
                set bat_zip=%%~a
        )
        !bat_poplog!
        
        if defined bat_zipfile (
                set bat_recent_error_msg=17.FOUND zip file - "!bat_zip!"
                !bat_echolog!
                !bat_echolog!
                !bat_echolog! '     17.FOUND zip file - "!bat_zip!"
                !bat_echolog!
                !bat_echolog!
        ) else (
                set bat_recent_error_msg=17.ERROR - no matching zip file found.
                !bat_echolog!
                !bat_echolog!
                !bat_echolog! '     !bat_recent_error_msg!
                !bat_echolog!
                !bat_echolog!
                goto :UPLOADFTP_END
        )
        
        if defined bat_FTPUPLOAD.alternate_FTPTRANSFER (
                !bat_log! call "!bat_exedir!\!bat_FTPUPLOAD.alternate_FTPTRANSFER!"
                          call "!bat_exedir!\!bat_FTPUPLOAD.alternate_FTPTRANSFER!"
        ) else (
                call :FTPTRANSFER
        )
        
:UPLOADFTP_END
!bat_poplog! [RETURN !bat_batchfile!:UPLOADFTP] [bat_retval!bat_retval!, bat_returncode=!bat_returncode!, bat_zipfile="!bat_zipfile!", bat_recent_error_msg=!bat_recent_error_msg!]
        if not defined autonomous (pause)
!bat_log!
!bat_return!







        rem 17. Upload Zip via FTP ************************************
:UPLOADFTPAUTO
!bat_pushlog! [CALL !bat_batchfile!:UPLOADFTPAUTO] %*
        set bat_retval=failed

        if /i "!bat_submissionfilesdir!" equ "" (
                !bat_echolog!
                !bat_echolog!     Run Submission before zipping: 
                if not defined bat_autonomous (
                        pause 
                        goto :UPLOADFTPAUTO_END
                )
        )

        if defined bat_FTPUPLOAD.alternate_FTPUPLOAD (
                !bat_log! call "!bat_exedir!\!bat_FTPUPLOAD.alternate_FTPUPLOAD!"
                          call "!bat_exedir!\!bat_FTPUPLOAD.alternate_FTPUPLOAD!"
                goto :UPLOADFTPAUTO_END
        )

                rem This is a one-time prompt. The password will be recorded into AutoCams.bat.ini
                rem and the question won't be asked again.
        if /i "!bat_ftppassword!" equ "" (
                !bat_echolog!
                !bat_echolog!
                set bat_choice=
                          !bat_prompt! Enter your email address as the anonymous FTP password: 
                !bat_log! set /P bat_choice=.!bat_pushstring!Enter your email address as the anonymous FTP password: !bat_choice!
                set bat_ftppassword=!bat_choice!
                !bat_log! set bat_ftppassword=!bat_ftppassword!
                call :SAVECONFIG
        )

        !bat_echolog! set bat_ftpfile=!bat_exedir!\ftp.temp.txt
                      set bat_ftpfile=!bat_exedir!\ftp.temp.txt
        
                rem Handle the case where an existing FTP with the same name has already been
                rem uploaded.  Since the users won't typically have delete rights, they will
                rem need to load a different file.  So, we need to list all the existing 
                rem zip files (in ascending date order), add a sequence number to the file name,
                rem and upload the newly sequenced file.  Of course, there is the likelihood that
                rem no file exists.
        set bat_zipfile=
        set bat_zip=
        !bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip" /a-d /b /od`^) do ...
        for               /f "usebackq tokens=*" %%a in  (`dir "!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip" /a-d /b /od`) do (
                set bat_zipfile=!bat_targetlocation!\CAMS\Submitted\%%~a
                set bat_zip=%%~a
        )
        !bat_poplog!

        if defined bat_zipfile (
                set bat_recent_error_msg=17.FOUND zip file - "!bat_zip!"
                !bat_echolog!
                !bat_echolog!
                !bat_echolog! '     17.FOUND zip file - "!bat_zip!"
                !bat_echolog!
                !bat_echolog!
        ) else (
                set bat_recent_error_msg=17.ERROR - no matching zip file found.
                !bat_echolog!
                !bat_echolog!
                !bat_echolog! '     !bat_recent_error_msg!
                !bat_echolog!
                !bat_echolog!
                goto :UPLOADFTP_END
        )

        if defined bat_FTPUPLOAD.alternate_FTPTRANSFER (
                !bat_log! call "!bat_exedir!\!bat_FTPUPLOAD.alternate_FTPTRANSFER!"
                          call "!bat_exedir!\!bat_FTPUPLOAD.alternate_FTPTRANSFER!"
        ) else (
                call :FTPTRANSFER
        )
        

:UPLOADFTPAUTO_END
!bat_poplog! [RETURN !bat_batchfile!:UPLOADFTPAUTO] [!bat_retval!, !bat_returncode!, "!bat_zipfile!" !bat_recent_error_msg!]
!bat_log!
!bat_return!





        rem Do an MD5 hash of the zip file for comparison
:FTPHASH
!bat_pushlog! [CALL !bat_batchfile!:FTPHASH] %*
        set bat_retval=
        set bat_hash=

        if not exist "%~1" (
                set bat_retval=1
                goto :FTPHASH_END
        )

        !bat_logexeclog! call md5 -o"!bat_exedir!\Logs\md5.output.log" "%~1"
        set bat_retval=!bat_logexec_returncode!
        
        if !bat_retval! equ 0 (
                for /f "usebackq tokens=1,*" %%X in ("!bat_exedir!\Logs\md5.output.log") do (
                        set bat_hash=%%X
                )
                
                if not defined bat_RetVal1 (
                        set bat_retval=3
                )
        )

        if exist "!bat_exedir!\Logs\md5.output.log" (
                if defined bat_exedir (
                        !bat_logexeclog! del /q "!bat_exedir!\Logs\md5.output.log"
                ) else (
                        !bat_echolog! ERROR [!bat_batchfile!:FTPHASH] Dangerous command: del /q "!bat_exedir!\Logs\md5.output.log"
                )
        )

:FTPHASH_END
!bat_poplog! [RETURN !bat_batchfile!:FTPHASH] [bat_retval=!bat_retval!, bat_hash=!bat_hash!]
!bat_log!
!bat_return!




:FTPTRANSFER
!bat_pushlog! [CALL !bat_batchfile!:FTPTRANSFER
        set bat_retval=failed

                rem Part of the FTP transfer session uploads with a PUT and then
                rem immediately downloads with a GET.  The downloaded file is
                rem temporarily placed in the Temp dir, so the dir needs to be there.
        if not exist "!bat_exedir!\Temp" (
                !bat_logexeclog! md "!bat_exedir!\Temp"
        )

                rem Test the zip before uploaded to ensure that it's good...
        call :FTP_TESTZIP "!bat_zipfile!"
        if /i "!bat_returncode!" neq "0" (
                goto :FTPTRANSFER_END
        )

        !bat_echolog! Now upload the file and then download it to .\Temp to test it 
        !bat_echolog! for validity...
        !bat_pushecho!

                echo user !bat_ftpuser!>"!bat_ftpfile!"
                echo !bat_ftppassword!>>"!bat_ftpfile!"
                echo bin>>"!bat_ftpfile!"
                echo cd !bat_ftpdir!>>"!bat_ftpfile!"
                echo literal pasv>>"!bat_ftpfile!"
                echo put "!bat_zipfile!">>"!bat_ftpfile!"
                echo lcd "!bat_exedir!\Temp">>!bat_ftpfile!"
                echo literal pasv>>"!bat_ftpfile!"
                echo get "!bat_zip!">>!bat_ftpfile!"
                echo quit>>"!bat_ftpfile!"

                !bat_logexec! type "!bat_ftpfile!"
                           
                !bat_echolog! '..............................................
        !bat_popecho!

        if /i "!bat_SIMULATION.ftp!" equ "true" (
                !bat_pushecho! SIMULATION - 
                        !bat_logexeclog! md "!bat_exedir!\Temp\SimulatedFTP"
                        !bat_logexeclog! copy /y "!bat_zipfile!" "!bat_exedir!\Temp\SimulatedFTP"
                        !bat_logexeclog! copy /y "!bat_exedir!\Temp\SimulatedFTP\!bat_zip!" "!bat_exedir!\Temp"
                !bat_popecho!
                set bat_returncode=0
        ) else (
                !bat_logexec! call ftp -n -s:"!bat_ftpfile!" !bat_ftpsite!
                set bat_returncode=!bat_logexec_returncode!
        )

        !bat_echolog!
        !bat_echolog! '    FTP exit code=!bat_returncode!
        !bat_echolog!

::CHECK_GET
        if not exist "!bat_exedir!\Temp\!bat_zip!" (
                set bat_recent_error_msg=17.ERROR - Failed FTP upload of "!bat_zipfile!" - can't find it in "!bat_exedir!\Temp".
                !bat_echolog!
                !bat_echolog!
                !bat_echolog! '    !bat_recent_error_msg!
                !bat_echolog!
                !bat_echolog!
                goto :FTPTRANSFER_END
        ) else (
                call :FTPHASH "!bat_zipfile!"
                set bat_hash_before=!bat_hash!
                
                call :FTPHASH "!bat_exedir!\Temp\!bat_zip!"
                set bat_hash_after=!bat_hash!
                
                if /i "!bat_hash_after!" neq "!bat_hash_before!" (
                        set bat_recent_error_msg=17.FAILED - target is different from the source. Something went wrong between uploading the file and downloading it again to check.  The file exists on the FTP server, but when it is downloaded from the FTP server it is different from the original.
                        !bat_echolog!
                        !bat_echolog!
                        !bat_echolog! '    !bat_recent_error_msg!
                        !bat_echolog!
                        !bat_echolog!
                ) else (
                        set bat_recent_error_msg=17.SUCCESS - Target is validated as the same on the FTP server as a test download of the same file via MD5 hash check.
                        !bat_echolog!
                        !bat_echolog!
                        !bat_echolog! '    !bat_recent_error_msg!
                        !bat_echolog!
                        !bat_echolog!
                )
                
                !bat_pushecho! Deleting the test download...
                if defined bat_exedir (
                        !bat_logexec! del /q "!bat_exedir!\Temp\!bat_zip!"
                ) else (
                        !bat_echolog! ERROR [!bat_batchfile!:CHECK_GET] Dangerous command: del /q "!bat_exedir!\Temp\!bat_zip!"
                )
                !bat_popecho!

                call :MOVETRANSMIT

                if /i "!bat_hash_after!" neq "!bat_hash_before!" (
                        goto :FTPTRANSFER_END
                )

                !bat_log!
                !bat_logexec! copy /y "!bat_logfile!" "!bat_archivedfilesdir!\AutoCams2.bat.log"

                set bat_retval=success
                set bat_recent_error_msg=17.SUCCESS - "!bat_zipfile!" - Target is validated as the same on the FTP server as a test download of the same file via MD5 hash check.
                !bat_echolog!
                !bat_echolog!
                !bat_echolog! '    !bat_recent_error_msg!
                !bat_echolog!
                !bat_echolog!
        )

:FTPTRANSFER_END
!bat_poplog! [RETURN !bat_batchfile!:FTPTRANSFER] [!bat_retval!, !bat_recent_error_msg!]
!bat_log!
!bat_return!




        rem Move to Transmitted
:MOVETRANSMIT
!bat_pushecho! [CALL !bat_batchfile!:MOVETRANSMIT] %*
        !bat_logexec! move /y "!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip" "!bat_targetlocation!\CAMS\Transmitted"

:MOVETRANSMIT_END
!bat_popecho! [RETURN !bat_batchfile!:MOVETRANSMIT] ["!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip"]
!bat_log!
!bat_return!




:FTP_TESTZIP [in] "!bat_zipfile!"
!bat_pushlog! [CALL !bat_batchfile!:FTP_TESTZIP] %*

        !bat_echolog! 'Test the zip file before uploading to ensure that it's good.
        !bat_echolog! 'The test involves:
        !bat_echolog! '  - The zip file must exist;
        !bat_echolog! '  - The hash code must not be the empty zip file hash
        !bat_echolog! '    If so, the zip file will be deleted.
        !bat_echolog! '  - The zip file is unzipped to Temp\Zip.  [The Temp\Zip dir
        !bat_echolog! '    is cleaned out before unzipping]
        !bat_echolog! '  - The Temp\Zip dir is cleaned up and the Temp\Zip dir is removed.
        !bat_echolog! '  - If there are no other errors, the 

        if not exist "%~1" (
                set bat_returncode=98
                set bat_recent_error_msg=17.ERROR - Not found: "%~1"
                !bat_echolog!
                !bat_echolog! '    !bat_recent_error_msg!
                !bat_echolog!
                goto :FTP_TESTZIP_END
        )

        call :FTPHASH "%~1"
        if /i "!bat_hash!" equ "76CDB2BAD9582D23C1F6F4D868218D6C" (
                set bat_returncode=99
                set bat_retval=failed
                set bat_recent_error_msg=17.ERROR - Empty zip file: "%~1"
                !bat_echolog!
                !bat_echolog! '    !bat_recent_error_msg!
                !bat_echolog!
                
                if "%~1" neq "" (
                        !bat_logexec! del /q "%~1"
                ) else (
                        !bat_echolog! ERROR [!bat_batchfile!:FTP_TESTZIP] Dangerous command: del /q "%~1"
                )
                goto :FTP_TESTZIP_END
        ) else (
                !bat_echolog! '    not a blank zip file...
        )
        
        if exist "!bat_exedir!\Temp\Zip" (
                !bat_log! // Cleaning up before unzipping...
                if defined bat_exedir (
                        !bat_logexeclog! del /s /q "!bat_exedir!\Temp\Zip"
                        !bat_logexeclog! rd /s /q "!bat_exedir!\Temp\Zip"
                ) else (
                        !bat_echolog! ERROR [!bat_batchfile!:FTPTESTZIP] Dangerous command: del /s /q "!bat_exedir!\Temp\Zip"
                        !bat_pause!
                        exit /b -98
                )
        )

        !bat_log! // Unzip the file to "..\Temp\Zip" and check for errorlevel

        !bat_logexeclog! call "!bat_exedir!\7za.exe" x -y -r -tzip -o"!bat_exedir!\Temp\Zip" "%~1" "*.*"
        set bat_returncode=!bat_logexec_returncode!

        !bat_log! // Cleanup after unzipping...
        if exist "!bat_exedir!\Temp\Zip" (
                if defined bat_exedir (
                        !bat_logexeclog! del /s /q "!bat_exedir!\Temp\Zip"
                        !bat_logexeclog! rd /s /q "!bat_exedir!\Temp\Zip"
                ) else (
                        !bat_echolog! ERROR [!bat_batchfile!:FTPTESTZIP] Dangerous command: del /s /q "!bat_exedir!\Temp\Zip"
                        !bat_pause!
                        exit /b -98
                )
        )

        !bat_log! // Comparing the hash codes...
        if /i !bat_returncode! equ 0 (
                set bat_retval=success
                set bat_recent_error_msg=17.SUCCESS - Zip file is OK and ready to upload: "%~1"
                !bat_echolog!
                !bat_echolog! '    !bat_recent_error_msg!
                !bat_echolog!
        ) else (
                set bat_retval=failed
                set bat_recent_error_msg=17.ERROR - Corrupt zip file: "%~1"
                !bat_echolog!
                !bat_echolog! '    !bat_recent_error_msg!
                !bat_echolog!
                goto :FTP_TESTZIP_END
        )

:FTP_TESTZIP_END
!bat_poplog! [RETURN !bat_batchfile!:FTP_TESTZIP] [!bat_retval!, !bat_returncode!, %~1]
!bat_log!
!bat_return!

