
rem Workaround
if /i "!bat_ftppassword!" equ "" (
	set bat_ftppassword=dave@davesamuels.com
)

:SETUP

	set bat_logexec_padding=                         
	set bat_logexec_flag=
	set bat_logexec_padding=[!date:~-10! !time!] 

	if not defined bat_logdir (
		rem echo................changing bat_logdir from "!bat_logdir!" to "!bat_exedir!\Logs"
		set bat_logdir=!bat_exedir!\Logs
	)

	if not exist "!bat_logdir!" (
		rem set bat_logdir=!bat_exedir!\Logs


		rem echo.   [indent_log.bat] -----------------------creating the following log dir: "!bat_logdir!"
		MD "!bat_logdir!"
	)

	if /i "!bat_batchfile!" equ "" (
		set bat_log_temp=----------------------------------------------------------ERROR bat_batchfile is empty string ----------------
		GOTO :LOG2
	)

	rem Echo only to the bat_logfile.
:LOG

	set bat_log_temp=%*
:LOG2
	set bat_logexec_teststr=!bat_log_temp:~0,1!
	
	if /i "!bat_logexec_teststr!" equ "`" (
		set bat_log_temp=!bat_log_temp:~1!
	)
	
	if /i "!bat_logexec_teststr!" equ "}" (
		set bat_logexec_flag=true
		set bat_log_temp=!bat_log_temp:~1!
	)

		REM Handle blank line
	if not defined bat_log_temp (
			rem You get here if there are no arguments [or only spaces]
			rem passed to the script.  This is common when all you want to
			rem do is output a blank line. This keeps it from logging "ECHO ON"

rem			echo.>>"!bat_logfile!" 2>&1
rem			echo.>>"!bat_logfile_full!" 2>&1
		
		goto :LOG_DEBUG
	)

		REM Don't display dates and line numbers for output of commands, like DIR and COPY and stuff...
	if NOT defined bat_logexec_flag (
		set bat_logexec_padding=[!date:~-10! !time!] 

	)
 
 
%BAT_COMMENT_BEGIN%
     		REM Include line numbers of the batch file if debug is true
	set bat_indent_line=
	set bat_indent_line_text=
	if /i "!bat_indent_log_debug!" equ "true" (

		for /f "usebackq tokens=1* delims=[] skip=2" %%M in  (`find /n "%~1" "!bat_batchfile!"`) do (

			set bat_indent_line=%%M
			set bat_indent_line_text=%%N
			echo.[!bat_indent_line!, !bat_batchfile!] "%~1"

			echo.[zzzzzzzzzzzzz!bat_indent_line! !bat_batchfile!] !bat_indent_line_text!>>"!bat_logfile!" 2>&1
			echo.[zzzzzzzzzzzzz!bat_indent_line! !bat_batchfile!] !bat_indent_line_text!
		)
		
		if not defined bat_indent_line (
		     set bat_logexec_padding=[!bat_indent_line! - !bat_batchfile!] !bat_logexec_padding!
		)
	)
%BAT_COMMENT_END%




:LOG_DEBUG
	if /i "!bat_indent_log_debug!" equ "true" (
		set bat_logexec_padding=!bat_logexec_padding!!bat_pushstring!
		echo.!bat_logexec_padding!!bat_pushstring!!bat_log_temp!
	)

	echo.!bat_logexec_padding!!bat_pushstring!!bat_log_temp!>>"!bat_logfile!" 2>&1
	echo.!bat_logexec_padding!!bat_pushstring!!bat_log_temp!>>"!bat_logfile_full!" 2>&1


:LOG_END

	REM Test for a bad bat_submissionfilesdir
	echo."!bat_submissionfilesdir!"|find /i "~">nul
	set bat_indent_junk=!errorlevel!
rem	echo.bat_indent_junk=!bat_indent_junk!



exit /b 0

