
:INDENT_PROMPT
	set bat_indent_pause=
	set bat_indent_prompt_string=!bat_prompt! .!bat_pushstring!%* 
	!bat_log! "indent_prompt.bat" .!bat_pushstring!%* 
	      set /p bat_indent_pause=.!bat_pushstring!%* 

	if /i "!bat_indent_pause!" equ "???" (
		CALL :HELP
		echo.
		goto :INDENT_PROMPT
	)

		rem Debug using indent_pause.bat, which could return a value as bat_indent_prompt. 
	if /i "!bat_indent_pause!" equ "ddd" (
		call "!bat_exedir!\indent_pause.bat" %*
	)

	if "!bat_indent_pause!" equ "" (goto :INDENT_PROMPT_END)
	if /i "!bat_indent_pause!" equ "q" (goto :INDENT_PROMPT_END)
	
:INDENT_PROMPT_END
	!bat_logexeclog! set bat_choice=!bat_indent_pause!

!bat_return!



:INDENT_PROMPT_ABORT
		REM force a syntax error in orderto guarantee that all loops and subroutines are aborted asap.
	for /f "useback" a in (1,1,1) do (x)

:INDENT_PROMPT_ABORT_END
!bat_return!


:HELP
	!bat_push!
	echo.Instructions:
	echo.
	echo.Usage: ^^!bat_prompt^^! .Select choice from these values [^^!bat_xyz^^!] :
	echo.
	echo.Ideal for debugging batch scripts.
	echo.
	echo.It Displays:
	echo.	^<dot^>^<indent spacing^>Your prompt string
	echo.
	echo.Returns:
	echo.    bat_choice
	echo.
	echo.When the user presses [Enter], it returns.
	echo.
	echo.If the user enters ??? [three question marks],
	echo.this help text appears.
	echo.
	echo.When the user enters: ddd
	echo.The prompt calls "indent_pause.bat", which is a prompt
	echo.that supports debugging commands. 
	echo.
	echo.When the user enters [Q], it sends "Q" to the calling program
	echo.
	!bat_pop!
!bat_return!
