@echo off

setlocal enabledelayedexpansion enableextensions

echo.
echo=======================================================================
echo %~f0   version 2.2.2

if /i {%~1} == {?} goto :HELP
if /i {%~1} == {/?} goto :HELP
if /i {%~1} == {-h} goto :HELP
if /i {%~1} == {/h} goto :HELP

echo Iterates through subdirs to do "md5build.bat" at each subdir.

set command="%~dp0md5build"
set command2=dir /s/b /ad

set filespec=%*
if {%1} equ { } set filespec=*.*
if {%1} equ {} set filespec=*.*

set filespec


  echo.
  echo Here is the list of directories that will be processed...
  echo This list is obtained by invoking this command^:
  echo   !command2!
  echo.
  echo They will by checked by changing to each directory and then 
  echo invoking the "!command!" script in each of the directories listed^: 

  echo.
  set md5.junkfile=c:\md5.junk.txt
  echo !cd!>!md5.junkfile!
  call !command2!|sort>>!md5.junkfile!
  echo ---------------------
  rem type !md5.junkfile!
  for /F "usebackq delims=<|>" %%a in ("!md5.junkfile!") do (
    echo     %%~fa
  )
  echo ---------------------

set cd_original=!cd!



@echo.

Echo Here is the list of commands that will be executed^:
for /f "usebackq delims=<|>" %%a in ("!md5.junkfile!") do (
  set command3=cd /d "%%~a"
  echo !command3!
  call !command3!
  echo !cd!
  echo call !command! !filespec!
  rem call !command! !filespec!
)

echo.
echo.
echo Starting the repeating commands...
echo.
echo.
@echo.
@echo     Note: It is safe to interrupt this process at any time.  Errors will be
@echo           logged in "C:\md5check.err.log".
@echo.
@echo           Reading files and computing the hash - please be patient, this can 
@echo           take several minutes for large files... (the caption bar will 
@echo           display the size of the files it is working on)
@echo.

rem goto :DONE


for /f "usebackq delims=<|>" %%a in ("!md5.junkfile!") do (
    set command3=cd /d "%%~a"
  echo.
  echo.
  echo !command3!
  call !command3!
  echo !cd!
  echo call !command! !filespec!
  call !command! !filespec!
)

echo.
echo %~n0 Finished at %time%
goto :DONE


:HELP
echo.
echo %~f0
echo :HELP
echo Batch file that runs %~dp0md5build.bat repeatedly.
echo Iterates through subdirs to call "md5build.bat" at each subdir.
echo.
echo Usage example 1: 
echo     %~n0
echo         Runs the script as if it was done as...
echo     %~n0 *.*
echo.
echo Usage example 2: 
echo     %~n0
echo         Runs the script as if it was done as...
echo     %~n0 *.*
echo.
echo Usage example 1: 
echo     %~n0
echo         Runs the script as if it was done as...
echo     %~n0 *.*
echo.
echo Usage example 1: 
echo     %~n0
echo         Runs the script as if it was done as...
echo     %~n0 *.*
goto :DONE

:DONE
del !md5.junkfile!
cd /d "!cd_original!"


