@echo off
rem This script should move files from the CapturedFiles, ArchivedFiles, 
rem and ConfirmedFiles, along with their matching Cal files into the 
rem SubmittedFiles directory.  

:SETUP
	setlocal enableextensions enabledelayedexpansion

	set retval=0
	
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP

:MAIN
	set move_sourcelocation=%~1%
	set move_sourcedrive=%move_targetlocation:~0,2%
	set move_sourcedirfull=%~1
	
	set move_destlocation=%~2

	set /a linecount=0
	echo !date! !time!>"Logs\%~nx0.log"
	

	call robocopy  
	

	if "%2" neq "" set move_targetdrive=%~2

	
exit /b %retval%


:HELP
	echo %0
	echo.
	echo Usage: %0 
	echo.
	echo Moves the files related to the date to the SubmittedFiles
	echo directory.
	echo.
goto :DONE

:DONE
exit /b %retval%