echo off
setlocal enableextensions enabledelayedexpansion


	REM #################################################################################
:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

:CHECKHELP_END
goto :SETUP %*



	REM #################################################################################
:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"
rem	set bat_pushstring=

	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - [%~dpnx0 %*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!

	set bat_returncode=0

	!bat_CALL! "!bat_exedir!\ReadParams.bat"
	
	if not defined bat_CALIBRATION.REMOTE_autocal_remote_cmdline (
		!bat_logexeclog! set bat_CALIBRATION.remote_autocal_remote_cmdline=start "" /low /min "!bat_camsdir!\MonitorDir.exe"        /FilenameChange /RunOnce /AddFileName /Creation /Activate     "!bat_camsdir!\Temp" "!bat_camsdir!\AutoCal_Remote.bat /zip"
	)
	
		!bat_echolog! !bat_CALIBRATION.REMOTE_autocal_workdir!
	set bat_mapped_From=!bat_CALIBRATION.REMOTE_autocal_workdir!
	
	!bat_echolog! !bat_CALIBRATION.REMOTE_autocal_remote_cmdline!
	              !bat_CALIBRATION.REMOTE_autocal_remote_cmdline!
	

	call MonitorDir_Poll_Server.bat !bat_camsdir!\temp